# -*- coding: utf-8 -*-
# default.py

import urllib,urllib2,re,xbmcplugin,xbmcgui,subprocess,sys,os,os.path,xbmcaddon
import json

# Plugin constants 
__addonid__ = "plugin.video.mfalbum"
__addon__ = xbmcaddon.Addon(id=__addonid__)
__cwd__ = __addon__.getAddonInfo('path')
__resource__  = xbmc.translatePath( os.path.join( __cwd__, 'lib' ) ).decode("utf-8")
sys.path.append (__resource__)
import getlist
import itvi_play


selectedList={}

def SetSelectType(source_id,seltype):
    selectedList[source_id]=seltype
    
def GetSelectType(source_id):
    if selectedList.has_key(source_id):
        return selectedList[source_id]
    else:
        return ""
    
def getDefinitionText(seltype):
    if seltype == "nd":
        return "流畅";
    elif seltype == "hd":
        return "高清"
    elif seltype == "sd":
        return "超清"
    elif seltype == "sd2":
        return "超高清"

def getDefinitionType(text):
    if text == "流畅":
        return "nd";
    elif text == "高清":
        return "hd"
    elif text == "超清":
        return "sd"
    elif text == "超高清": 
        return "sd2"

def playVideo(source_id,url,additional_property_dict,source_kind,item_id,spiderName,videoParam,name):
    resultstr = xbmc.getRealUrl(source_id, url,"AnalysisRealUrlForMorefun","",source_kind,item_id,spiderName,videoParam)
    retlist=resultstr.split("~:")
    if len(retlist) > 2 and retlist[1] != "0" and retlist[2] == "0":
        resultstr = xbmc.getRealUrl(source_id, url,"AnalysisRealUrlForMorefun","",source_kind,item_id,spiderName,"<defFormat>m3u8</defFormat>")
    real_list = []
    select_text = ""
    if resultstr:
        retlist=resultstr.split("~:")
        if len(retlist)>2:
            resultstr=retlist[0]
            if retlist[2]=="1":  #canceled by user
                return
            if retlist[1]!="0":
                real_list.append("errcode")
                real_list.append(retlist[1])
                if xbmc.isSupportWebAnalysis(spiderName,'Android',url):
                    dialog = xbmcgui.Dialog()
                    ret = dialog.yesno("提示","是否进行原网页播放？")
                    if ret:
                        xbmc.executebuiltin('StartAndroidMfActivity("org.morefun.morefuntv","org.morefun.morefunie.MainActivity","","","morefun://morefunie/?params=<pageType>video</pageType><mfurl>%s</mfurl>")' %url)
                return real_list
        rtjson = json.JSONDecoder().decode(resultstr)
        dtypes = []    
        for seltype in ('sd2','sd','hd','nd'):    
            if rtjson.has_key(seltype):    
                dtypes.append(getDefinitionText(seltype))    
                select_text = getDefinitionText(seltype)    
        if len(dtypes) > 1 and (GetSelectType(source_id) not in dtypes):    
            dialog = xbmcgui.Dialog()    
            ret = dialog.select('请选择视频清晰度', dtypes)    
            if ret >= 0:    
                select_text = dtypes[ret]    
            else:    
                real_list.append("usercancel")    
                return real_list    
        elif len(dtypes) == 1:    
            select_text = dtypes[0]    
        else:    
            select_text = GetSelectType(source_id)    
        SetSelectType(source_id,select_text)    
                
        if rtjson.has_key("callback"):    
            resultstr = xbmc.getRealUrl(source_id, url,"AnalysisRealUrlItems",getDefinitionType(select_text),source_kind,item_id,spiderName,videoParam)    
            retlist=resultstr.split("~:")    
            if len(retlist)>2:    
                resultstr=retlist[0]    
                if retlist[2]=="1":  #canceled by user
                    return
                if retlist[1]!="0":    
                    real_list.append("errcode")    
                    real_list.append(retlist[1])    
                    if xbmc.isSupportWebAnalysis(spiderName,'Android',url):
                        dialog = xbmcgui.Dialog()
                        ret = dialog.yesno("提示","是否进行原网页播放？")
                        if ret:
                            xbmc.executebuiltin('StartAndroidMfActivity("org.morefun.morefuntv","org.morefun.morefunie.MainActivity","","","morefun://morefunie/?params=<pageType>video</pageType><mfurl>%s</mfurl>")' %url)
                    return real_list
            rtjson = json.JSONDecoder().decode(resultstr)    
        real_list = rtjson[getDefinitionType(select_text)]    
                
        if rtjson.has_key("video_properties"):    
            video_properties=rtjson["video_properties"]    
            if video_properties:    
                for key in video_properties.keys():    
                    keystr=str(key)    
                    if keystr.endswith("_"+getDefinitionType(select_text)):    
                        keystr=keystr[0:-len(getDefinitionType(select_text))-1]    
                    #additional_property_dict[keystr]=str(video_properties.get(str(key)))    
    playlist = xbmc.PlayList(1)
    playlist.clear()
    for i in range(0,len(real_list)):
        title =name+" 第"+str(i+1)+"/"+str(len(real_list))+"节"
        listitem=xbmcgui.ListItem(title)
        listitem.setInfo(type="Video",infoLabels={"Title":title})
        listitem.setProperty('itemId',item_id)
        listitem.setProperty('playerRequired',"dvdplayer")
        listitem.setProperty('webUrl',url)
        listitem.setProperty('spiderName',spiderName)
        playlist.add(real_list[i], listitem)
    xbmc.Player().play(playlist)
    

params = getlist.get_params()
mode = None
url = None
page = 1
type = ''

app_id = ''
category_id = ''
area_id = ''
style_id = ''
released_on_from = ''
released_on_to = ''
page_size = ''
resid = ''
item_id = ''
appspidername = ''
maxpage = ''
name = ''
search_path = ''
keyword = ''
searchpage = ''
title = ''
year = ''
actors = ''
resappepisodes = ''
areaname = ''
stylename = ''
thumbnail = ''
get_type = ''
bg_num = 0
albumname = ''
subappimagebg = ''
fromtype = ''
resourceTitle = ''
albumid = ''
appidlist = ''
appnamelist = ''
view_mode = ''

try:
    url = urllib.unquote_plus(params["url"])
except:
    pass
try:
    mode = int(params["mode"])
except:
    pass
try:
    page = int(params["page"])
except:
    pass
try:
    searchpage = int(params["searchpage"])
except:
    pass
try:
    type = urllib.unquote_plus(params["type"])
except:
    pass
try:
    app_id = urllib.unquote_plus(params["app_id"])
    if app_id == "0":
        app_id = ""
except:
    pass
try:
    category_id = int(params["category_id"])
except:
    pass
try:
    area_id = urllib.unquote_plus(params["area_id"])
    if area_id == "0":
        area_id = ""
except:
    pass
try:
    style_id = urllib.unquote_plus(params["style_id"])
    if style_id == "0":
        style_id = ""
except:
    pass
try:
    released_on_from = urllib.unquote_plus(params["released_on_from"])
    if released_on_from == "0":
        released_on_from = ""
except:
    pass
try:
    released_on_to = urllib.unquote_plus(params["released_on_to"])
    if released_on_to == "0":
        released_on_to = ""
except:
    pass
try:
    page_size = int(params["page_size"])
except:
    pass
try:
    resid = int(params["resid"])
except:
    pass
try:
    item_id = int(params["item_id"])
except:
    pass
try:
    appspidername = urllib.unquote_plus(params["appspidername"])
except:
    pass
try:
    maxpage = int(params["maxpage"])
except:
    pass
try:
    name = urllib.unquote_plus(params["name"])
except:
    pass
try:
    search_path = urllib.unquote_plus(params["search_path"])
except:
    pass
try:
    keyword = urllib.unquote_plus(params["keyword"])
except:
    pass
try:
    title = urllib.unquote_plus(params["title"])
except:
    pass
try:
    year = urllib.unquote_plus(params["year"])
except:
    pass
try:
    actors = urllib.unquote_plus(params["actors"])
except:
    pass
try:
    areaname = urllib.unquote_plus(params["areaname"])
except:
    pass
try:
    stylename = urllib.unquote_plus(params["stylename"])
except:
    pass
try:
    resappepisodes = urllib.unquote_plus(params["resappepisodes"])
except:
    pass
try:
    thumbnail = urllib.unquote_plus(params["thumbnail"])
except:
    pass
try:
    get_type = urllib.unquote_plus(params["get_type"])
except:
    pass
try:
    bg_num = int(params["bg_num"])
except:
    pass
try:
    albumname = urllib.unquote_plus(params["albumname"])
except:
    pass
try:
    subappimagebg = urllib.unquote_plus(params["subappimagebg"])
except:
    pass
try:
    fromtype = urllib.unquote_plus(params["fromtype"])
except:
    pass
try:
    resourceTitle = urllib.unquote_plus(params["resourceTitle"])
except:
    pass
try:
    albumid = urllib.unquote_plus(params["albumid"])
except:
    pass
try:
    appidlist = urllib.unquote_plus(params["appidlist"])
except:
    pass
try:
    appnamelist = urllib.unquote_plus(params["appnamelist"])
except:
    pass
try:
    view_mode = urllib.unquote_plus(params["view_mode"])
except:
    pass

if get_type:
    if get_type == "area":
        getlist.getareas()
    elif get_type == "style":
        getlist.getstyles()
    elif get_type == "year":
        getlist.getyears()
    elif get_type == "sources":
        getlist.getsources(appidlist,appnamelist)
elif fromtype == 'history':
    getlist.display_for_history(params)
elif fromtype == 'favourite':
    getlist.display_for_favourite(params)
elif fromtype == 'updateFavourite':
    getlist.update_favourite(params)

elif mode == None:
    getlist.buildRoot()
    #getlist.getAlbums()
elif mode == 1:
    getlist.buildLists(app_id,category_id,area_id,url,page,style_id,released_on_from,released_on_to,albumname,subappimagebg)
elif mode == 2:
    getlist.buildNextLists(url,app_id,resid,page,resappepisodes,thumbnail)
elif mode == 3:
    source_id = int(app_id)
    additional_property_dict = "AnalysisRealUrlForMorefun"
    source_kind = ""
    item_id = str(item_id)
    spiderName = appspidername
    videoParam = ""
    #playVideo(source_id,url,additional_property_dict,source_kind,item_id,spiderName,videoParam,name)
    properties = {}
    properties['itemType'] = 'morefun'
    properties['sourceId'] = source_id
    properties['url'] = url
    properties['sourceKind'] = source_kind
    properties['itemId'] = item_id
    properties['spiderName'] = spiderName
    properties['videoParam'] = videoParam
    properties['title'] = name
    properties['resourceTitle'] = resourceTitle
    properties['thumb'] = thumbnail
    
    folderpath = xbmc.getInfoLabel('container.folderpath')
    pos = folderpath.find('?')
    host = folderpath[0:pos]
    params = getlist.get_params(folderpath[pos:])
    app_id = params['app_id'] if 'app_id' in params else ''
    resid = params['resid'] if 'resid' in params else ''
    page = params['page'] if 'page' in params else ''
    resappepisodes = params['resappepisodes'] if 'resappepisodes' in params else ''
    thumbnail = params['thumbnail'] if 'thumbnail' in params else ''
    parentPath = host+'?fromtype=history&app_id='+app_id+'&resid='+resid+'&page='+page+'&resappepisodes='+resappepisodes+'&thumbnail='+thumbnail+'&need_type='+urllib.quote_plus('source')
    properties['parentPath'] = parentPath
    
    player = itvi_play.ItviItemPlayer()
    player.play(properties)
elif mode == 4:
    #getlist.setarea()
    getlist.getSubAlbumAndResources(albumid, view_mode, page)
elif mode == 5:
    getlist.performChange(app_id,category_id,url)
elif mode == 6:
    getlist.setres(url,resid,resappepisodes,thumbnail)
elif mode == 7:
    getlist.selectpage(url,app_id,resid,maxpage,resappepisodes,thumbnail)
elif mode == 8:
    getlist.searchkey('')
elif mode == 9:
    getlist.searchlist(keyword,category_id,searchpage)
