# -*- coding: utf-8 -*-
# getlist.py

import urllib,urllib2,re,xbmcplugin,xbmcgui,sys,os,os.path,xbmcaddon,xbmc
from urlparse import urljoin
import json
import gzip
try:
    from cStringIO import StringIO
except ImportError:
    from StringIO import StringIO
from xbmcswift2 import Plugin
plugin = Plugin()
try:
    from MFSearchKeyboard import Keyboard
except:
    from xbmc import Keyboard
    pass



plugin_path = plugin.addon.getAddonInfo('path')
lib_path = os.path.join(plugin_path, 'lib')

import time


__addonid__ = "plugin.video.mfiqiyi"
__addon__ = xbmcaddon.Addon(id=__addonid__)
RESOURCES_PATH = os.path.join(__addon__.getAddonInfo('path'), 'media', )
PAGING_THUMB = os.path.join(RESOURCES_PATH,'paging.png')
MORE_THUMB = os.path.join(RESOURCES_PATH,'more.png')
MOVIE_THUMB = os.path.join(RESOURCES_PATH,'1movie.png')
TV_THUMB = os.path.join(RESOURCES_PATH,'2tv.png')
COMIC_THUMB = os.path.join(RESOURCES_PATH,'3comic.png')
SHOW_THUMB = os.path.join(RESOURCES_PATH,'4show.png')
FUN_THUMB = os.path.join(RESOURCES_PATH,'5fun.png')
MICRO_THUMB = os.path.join(RESOURCES_PATH,'6micromovie.png')
GAMES_THUMB = os.path.join(RESOURCES_PATH,'7games.png')
KID_THUMB = os.path.join(RESOURCES_PATH,'8kid.png')
WAR_THUMB = os.path.join(RESOURCES_PATH,'9war.png')
RECODER_THUMB = os.path.join(RESOURCES_PATH,'10recoder.png')
MUSIC_THUMB = os.path.join(RESOURCES_PATH,'12music.png')
SPORT_THUMB = os.path.join(RESOURCES_PATH,'13sport.png')
STYLE_THUMB = os.path.join(RESOURCES_PATH,'14style.png')
TRIP_THUMB = os.path.join(RESOURCES_PATH,'15trip.png')
INFO_THUMB = os.path.join(RESOURCES_PATH,'16info.png')
LIFE_THUMB = os.path.join(RESOURCES_PATH,'17life.png')
BUSINESS_THUMB = os.path.join(RESOURCES_PATH,'18business.png')
CAR_THUMB = os.path.join(RESOURCES_PATH,'19car.png')
JOCK_THUMB = os.path.join(RESOURCES_PATH,'20jock.png')
AD_THUMB = os.path.join(RESOURCES_PATH,'21ad.png')
EDU_THUMB = os.path.join(RESOURCES_PATH,'22educate.png')
CREATION_THUMB = os.path.join(RESOURCES_PATH,'23creation.png')
TIT_MOV_THUMB = os.path.join(RESOURCES_PATH,'11tit_movie.png')
TIT_TV_THUMB = os.path.join(RESOURCES_PATH,'11tit_tv.png')


movie_areas = [['全部', ''],['华语','1'],['美国','2'],['欧洲','3'],['韩国','4'],['其他','5'],['日本','308'],['泰国','1115']]
movie_styles = [['全部', ''],['爱情','6'],['战争','7'],['喜剧','8'],['科幻','9'],['恐怖','10'],['动作','11'],['动画','12'],['悲剧','13'],['灾难','14'],['剧情','127'],['惊悚','128'],['魔幻','129'],['青春','130'],['枪战','131'],['传记','132'],['艺术','133'],['其它','134'],['伦理','288'],['悬疑','289'],['犯罪','291'],['歌舞','294'],['运动','295'],['原声','296'],['粤语','311'],['超清','999'],['奇幻','1284']]

tv_areas = [['全部', ''],['内地','15'],['香港','16'],['韩国','17'],['美剧','18'],['其它','19'],['日本','309'],['泰国','1114'],['台湾','1117']]
tv_styles = [['全部', ''],['言情','20'],['历史','21'],['武侠','23'],['古装','24'],['年代','27'],['农村','29'],['偶像','30'],['悬疑','32'],['科幻','34'],['喜剧','135'],['宫廷','139'],['商战','140'],['神话','145'],['穿越','148'],['罪案','149'],['谍战','290'],['粤语','315'],['超清','1000'],['青春','1653'],['家庭','1654'],['军旅','1655']]

comic_areas = [['全部', ''],['大陆','37'],['日本','38'],['美国','39'],['其它','40'],['法国','1105'],['韩国','1106'],['英国','1107'],['新西兰','1145'],['俄罗斯','1194']]
comic_styles = [['全部', ''],['动作','41'],['热血','42'],['机战','43'],['战争','44'],['古代','45'],['未来','46'],['侦探','47'],['冒险','48'],['竞技','49'],['体育','50'],['搞笑','51'],['言情','52'],['校园','53'],['都市','54'],['魔幻','55'],['科幻','56'],['耽美','58'],['剧情','59'],['悬疑','60'],['宠物','61'],['LOLI','62'],['ACG','63'],['Cosplay','64'],['励志','297'],['益智','298'],['童话','299'],['真人','300'],['神话','301'],['青春','302'],['亲子','316'],['原创','1092'],['传媒大学作品','1094'],['电影学院作品','1095'],['动画电影','1096'],['教育','1108'],['怀旧','1309'],['同人','2297'],['短片','2298']]

show_areas = [['全部', ''],['内地','151'],['港台','152'],['日韩','153'],['欧美','154'],['其它','1113']]
show_styles = [['全部', ''],['播报','155'],['访谈','156'],['搞笑','157'],['游戏','158'],['选秀','159'],['时尚','160'],['其它','161'],['情感','163'],['盛会','292'],['曲艺','293'],['粤语','1002'],['美食','1003'],['少儿','2117'],['脱口秀','2118'],['职场','2119'],['相亲','2120'],['歌舞','2121'],['伦理','2122'],['真人秀','2224']]

fun_areas = [['全部', ''],['内地','184'],['港台','185'],['日韩','186'],['海外','187'],['其它','188']]
fun_styles = [['全部', ''],['电影','1077'],['电视','1078'],['音乐','1079'],['演出','1080'],['明星','1081'],['综艺','1082'],['其它','1083'],['公益','1656'],['曲艺','2296'],['啪啪奇','4470']]

micromovie_styles = [['全部', ''],['明星','1293'],['歌舞','1294'],['文艺','1295'],['喜剧','1296'],['爱情','1297'],['动作','1298'],['奇幻','1299'],['惊悚','1300'],['悬疑','1301'],['青春','1302'],['温情','1303'],['励志','1304'],['公益','1305'],['酷儿','1306'],['广告','1307'],['其它','1308'],['体育','1315'],['社会','2287'],['伦理','2288'],['恶搞','2289'],['乡土','2290'],['啪啪奇','2329']]

games_styles = [['全部', ''],['网络游戏','21275'],['电子竞技','21276'],['单机游戏','21277'],['手机游戏','21278'],['游戏美女','21279']]

kid_areas = [['全部', ''],['大陆',''],['港台',''],['欧美',''],['日韩',''],['其它','']]
kid_styles = [['全部', ''],['动画',''],['少儿综艺',''],['早教益智','']]

war_styles = [['全部', ''],['军情','21789'],['深度','21790'],['兵器','21791'],['战史','21792'],['人物','21793']]

recoder_styles = [['全部', ''],['人物','70'],['社会','71'],['军事','72'],['探索','73'],['历史','74'],['地理','75'],['自然','76'],['文化','77'],['其它','78'],['典藏','79'],['奇艺','162'],['旅游','310'],['公开课','989']]

music_areas = [['全部', ''],['非洲','215'],['亚洲','216'],['拉美','217'],['日韩','218'],['欧美','219'],['港台','220'],['内地','221']]
music_styles = [['全部', ''],['流行','222'],['民谣','223'],['摇滚','224'],['另类','226'],['说唱','227'],['爵士','228'],['拉丁','229'],['乡村','230'],['Disco','231'],['哥特','232'],['电子','233'],['朋克','234'],['金属','235'],['古典','236'],['独立','237'],['民族','238'],['世界','239'],['其它','240'],['节奏布鲁斯','20373'],['轻音乐','20392'],['国际','20397'],['新世纪','20416'],['声乐','20446'],['影视','20452'],['雷鬼','20490'],['先锋','20507']]

sport_styles = [['全部', ''],['足球',''],['篮球',''],['网球',''],['高尔夫',''],['赛车',''],['极限运动',''],['台球',''],['其它','']]

style_styles = [['全部', ''],['服饰',''],['美容',''],['生活',''],['其它','']]

trip_areas = [['全部', ''],['安徽','599'],['北京','576'],['河南','607'],['湖南','611'],['江苏','595'],['辽宁','589'],['西藏','625'],['埃及','567'],['法国','520'],['日本','426'],['新西兰','380'],['意大利','371'],['马尔代夫','460'],['澳大利亚','559']]
trip_styles = [['全部', ''],['风光','354'],['饮食','355'],['出行','638'],['住宿','356']]

info_styles = [['全部', ''],['社会','20031'],['科技','20321'],['军事','21314'],['评论','21315'],['国内','21739'],['国际','21740'],['粤语新闻','21397']]

life_areas = [['全部', ''],['国内','1881'],['国外','1882']]
life_styles = [['全部', ''],['科技','1873'],['奇闻','1876'],['健康','1878'],['家居','1879'],['美尚','1898'],['汽车','1899'],['婚嫁','2115'],['美食','2218'],['健身','2225'],['舞蹈','2226'],['休闲','2227'],['萌宠','2228'],['魔术','2229'],['情感','2230'],['亲子','2231'],['啪啪奇','2326']]

business_styles = [['全部', ''],['宏观','2233'],['民生','2234'],['产经','2235'],['市场','2236'],['理财','2237'],['访谈','2238']]

car_areas = [['全部', ''],['国内','20554'],['欧洲','20555'],['亚洲','20556'],['北美','20557']]
car_styles = [['全部', ''],['微型','20542'],['小型','20543'],['紧凑型','20544'],['中型','20545'],['中高型','20546'],['豪华','20547'],['MPV','20548'],['SUV','20549'],['跑车','20550'],['皮卡','20551'],['微客','20552']]

jock_areas = [['全部', ''],['国内','1907'],['国外','1908']]
jock_styles = [['全部', ''],['自爆','1900'],['原创','1901'],['恶搞','1902'],['相声','1903'],['小品','1904'],['宠物','1905'],['屌丝','1906'],['童趣','1909'],['方言','1910'],['啪啪奇','2327'],['欢乐精选','22169'],['宅男宅女','22170'],['爆笑节目','22171'],['雷人囧事','22172']]

ad_areas = [['全部', ''],['国内','1869'],['国外','1870']]
ad_styles = [['全部', ''],['明星','1859'],['公益','1860'],['欧美','1861'],['形象','1862'],['搞笑','1863'],['时尚','1864'],['儿童','1865'],['生活','1866'],['性感','1867'],['热门','1868']]

educate_styles = [['全部', ''],['幼儿','1934'],['小学','1935'],['初中','1936'],['高中','1937'],['外语','1939'],['职业','1940'],['管理','1941'],['学历','2111'],['公开课','2124'],['实用教程','21436']]

creation_styles = [['全部', ''],['动画','21317'],['音乐','21319'],['搞笑','21320'],['生活','21321'],['极客','21414'],['微电影','21318'],['啪啪奇','21413']]

tit_movie_areas = [['全部', ''],['华语','1'],['美国','2'],['欧洲','3'],['韩国','4'],['泰国','1115'],['其它','5']]
tit_movie_styles = [['全部', ''],['动作','11'],['喜剧','8'],['爱情','6'],['惊悚','128'],['科幻','9'],['恐怖','10'],['剧情','127'],['战争','7'],['枪战','131'],['魔幻','129'],['青春','130'],['灾难','14'],['悲剧','13'],['艺术','133'],['传记','132'],['动画','12'],['犯罪','291'],['伦理','288'],['悬疑','289'],['运动','295']]

tit_tv_areas = [['全部', ''],['内地','15'],['香港','16'],['韩国','17'],['美剧','18'],['泰国','1114'],['台湾','1117'],['其它','19']]
tit_tv_styles = [['全部', ''],['青春','1653'],['家庭','1654'],['军旅','1655'],['言情','20'],['古装','24'],['武侠','23'],['偶像','30'],['谍战','290'],['罪案','149'],['宫廷','139'],['喜剧','135'],['悬疑','32'],['历史','21'],['年代','27'],['农村','29'],['穿越','148'],['商战','140'],['科幻','34']]

full_years = [['全部', '', ''], ['2011-2014', '2011_2014', ''], ['2000-2010', '2000_2010', ''], ['90年代', '199', ''], ['80年代', '198', ''], ['更早', '19700', '']]

void_years = []

void_areas = []

HOST = 'http://list.iqiyi.com/www/'


def GetHttpData(url):
    req = urllib2.Request(url)
    response = urllib2.urlopen(req)
    httpdata = response.read()
    if response.headers.get('content-encoding', None) == 'gzip':
        httpdata = gzip.GzipFile(fileobj=StringIO.StringIO(httpdata)).read()
    response.close()
    match = re.compile('encodingt=(.+?)"').findall(httpdata)
    if len(match)<=0:
        match = re.compile('meta charset="(.+?)"').findall(httpdata)
    if len(match)>0:
        charset = match[0].lower()
        if (charset != 'utf-8') and (charset != 'utf8'):
            httpdata = unicode(httpdata, charset).encode('utf8')
    return httpdata

def fetch_url(url, data=None, headers={}, timeout=None, proxies=None):
    headers.setdefault(
        'User-Agent', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1872.0 Safari/537.36')  # noqa
    headers.setdefault('Accept-Encoding', 'gzip,deflate')
    if data and isinstance(data, dict):
        data = urlencode(data)
    req = urllib2.Request(url, data, headers)
    http_proxy = None
    if proxies or http_proxy:
        if not proxies:
            if isinstance(http_proxy, basestring):
                proxies = {'http': http_proxy, 'https': http_proxy}
            else:
                proxies = http_proxy
        proxy_handler = urllib2.ProxyHandler(proxies)
        opener = urllib2.build_opener(proxy_handler)
        r = opener.open(req, timeout=timeout)
    else:
        r = urllib2.urlopen(req, timeout=timeout)
    content = r.read()
    if r.headers.get('content-encoding') == 'gzip':
        content = gzip.GzipFile(fileobj=StringIO(content), mode='rb').read()
    return content

def buildRoot():
    listitem=xbmcgui.ListItem('电影',thumbnailImage=MOVIE_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('电影')+"&category_id="+urllib.quote_plus('1')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('movie')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('电视剧',thumbnailImage=TV_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('电视剧')+"&category_id="+urllib.quote_plus('2')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('tv')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('动漫',thumbnailImage=COMIC_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('动漫')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('comic')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('综艺',thumbnailImage=SHOW_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('综艺')+"&category_id="+urllib.quote_plus('6')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('show')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('娱乐',thumbnailImage=FUN_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('娱乐')+"&category_id="+urllib.quote_plus('7')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('fun')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('微电影',thumbnailImage=MICRO_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('微电影')+"&category_id="+urllib.quote_plus('16')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('micromovie')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('游戏',thumbnailImage=GAMES_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('游戏')+"&category_id="+urllib.quote_plus('8')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('games')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('少儿',thumbnailImage=KID_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('少儿')+"&category_id="+urllib.quote_plus('15')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('kid')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('军事',thumbnailImage=WAR_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('军事')+"&category_id="+urllib.quote_plus('28')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('war')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('纪录片',thumbnailImage=RECODER_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('纪录片')+"&category_id="+urllib.quote_plus('3')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('recoder')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('音乐',thumbnailImage=MUSIC_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('音乐')+"&category_id="+urllib.quote_plus('5')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('music')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('体育',thumbnailImage=SPORT_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('体育')+"&category_id="+urllib.quote_plus('17')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('sport')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('时尚',thumbnailImage=STYLE_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('时尚')+"&category_id="+urllib.quote_plus('13')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('style')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('旅游',thumbnailImage=TRIP_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('旅游')+"&category_id="+urllib.quote_plus('9')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('trip')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('资讯',thumbnailImage=INFO_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('资讯')+"&category_id="+urllib.quote_plus('25')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('info')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('生活',thumbnailImage=LIFE_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('生活')+"&category_id="+urllib.quote_plus('21')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('life')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('财经',thumbnailImage=BUSINESS_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('财经')+"&category_id="+urllib.quote_plus('24')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('business')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('汽车',thumbnailImage=CAR_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('汽车')+"&category_id="+urllib.quote_plus('26')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('car')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('搞笑',thumbnailImage=JOCK_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('搞笑')+"&category_id="+urllib.quote_plus('22')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('jock')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('广告',thumbnailImage=AD_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('广告')+"&category_id="+urllib.quote_plus('20')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('ad')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('教育',thumbnailImage=EDU_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('教育')+"&category_id="+urllib.quote_plus('12')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('educate')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('原创',thumbnailImage=CREATION_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('原创')+"&category_id="+urllib.quote_plus('27')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('creation')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('电影片花',thumbnailImage=TIT_MOV_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('电影片花')+"&category_id="+urllib.quote_plus('1007')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('tit_movie')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('电视剧片花',thumbnailImage=TIT_TV_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('电视剧片花')+"&category_id="+urllib.quote_plus('1006')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('tit_tv')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def buildLists(category_id,page,area_id,style_id,released_on_from,released_on_to,medianame):
    if category_id =='1':
        url = HOST + str(category_id) + '/' + str(area_id) + '-' + str(style_id) + '---------0-' + str(released_on_from) + '-2-1-' + str(page) + '-1---.html'
    elif category_id =='4' or category_id =='2' or category_id =='6' or category_id =='15':
        url = HOST + str(category_id) + '/' + str(area_id) + '-' + str(style_id) + '----------' + str(released_on_from) + '-2-1-' + str(page) + '-1---.html'
    elif category_id =='12':
        url = HOST + str(category_id) + '/--' + str(style_id) + '-' + str(area_id) + '-------0--2-1-' + str(page) + '-1---.html'
    elif category_id =='16' or category_id =='26':
        url = HOST + str(category_id) + '/--'+str(style_id)+'-'+str(area_id)+'---------2-1-'+str(page)+'-1---.html'
    elif category_id =='7' or category_id =='13':
        url = HOST + str(category_id) + '/--' + str(area_id) + '--' + str(style_id) + '--------2-1-' + str(page) + '-1---.html'
    elif category_id =='1007':
        url = HOST + '10/' + str(category_id) + '-' + str(area_id) + '--' + str(style_id) + '---------2-1-' + str(page) + '-3---.html'
    elif category_id =='1006':
        url = HOST + '10/' + str(category_id) + '--' + str(area_id) + '-' + str(style_id) + '---------2-1-' + str(page) + '-3---.html'
    elif category_id =='5':
        url = HOST + str(category_id) + '/' + str(area_id) + '---' + str(style_id) + '-------0--2-1-' + str(page) + '-1---.html'
    elif category_id =='3':
        url = HOST + str(category_id) + '/' + str(style_id) + '-' + str(area_id) + '---------0--2-1-' + str(page) + '-1---.html'
    else:
        url = HOST + str(category_id) + '/' + str(style_id) + '-' + str(area_id) + '-----------2-1-' + str(page) + '-1---.html'
    
    items,maxpage = get_video_list_from_url(url)
    
    for i in items:
        name = i["title"].encode("utf-8")
        resappepisodes = i["resAppEpisodes"]
        url = i["url"]
        thumbnail = i["thumbnail"].encode("utf-8")
        listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
        if category_id != "1" and category_id != '7' and category_id != '16' and category_id != '28' and category_id != '1007' and category_id != '1006' and category_id != '5' and category_id != '17' and category_id != '20' and category_id != '27':
            listitem.setProperty('v360resappepisodes',resappepisodes)
        u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url)+"&name="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+'&category_id='+urllib.quote_plus(category_id)+'&resappepisodes='+urllib.quote_plus(str(resappepisodes))+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(items))
    if int(maxpage) > int(page):
        listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多 ' + str(page) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=MORE_THUMB)
        u=sys.argv[0] + '?mode=1&page='+str(page+1) +'&category_id='+urllib.quote_plus(category_id)+'&area_id='+urllib.quote_plus(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&released_on_from=' + urllib.quote_plus(released_on_from)+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb2')
    xbmcplugin.setProperty(int(sys.argv[1]), 'SencondFolder', medianame)
    if category_id == '1' or category_id == '2' or category_id == '4' or category_id == '6':
        xbmcplugin.setProperty(int(sys.argv[1]),'search_show','able')
    else:
        xbmcplugin.setProperty(int(sys.argv[1]),'search_show','unable')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def get_video_list_from_url(url):
    items = []
    maxpage = '0'
    content = fetch_url(url)
    _RE1 = re.compile(r'<div class="list0">([\s\S]*?)<!--分页 begin-->[\s\S]*?')
    _RE2 = re.compile(r'<li[\s\S]*?>([\s\S]*?)</li>[\s\S]*?')
    _RE3 = re.compile(
                    r'<a class="imgBg1 pic_list"[\s\S]*?href="([\s\S]*?)"[\s\S]*?'
                    'alt="([\s\S]*?)"[\s\S]*?'
                    'src="([\s\S]*?)"[\s\S]*?'
                    )
    _RE_resAppEpisodes = re.compile(r'<a class="imgBg1 pic_list"[\s\S]*?<span class="imgBg1C">([\s\S]*?)</span>[\s\S]*?')
    if _RE1.search(content):
        match = _RE1.search(content)
        datapag = match.groups()[0]
        for match in _RE2.finditer(str(datapag)):
            datapag1 = match.groups()[0]
            for match in _RE3.finditer(str(datapag1)):
                detail_url, title, imgurl = match.groups()
            if _RE_resAppEpisodes.search(str(datapag1)):
                match = _RE_resAppEpisodes.search(str(datapag1))
                episodes_num = match.groups()[0]
            else:
                episodes_num = ''
            items.append({
                'title': title,
                'url': detail_url,
                'thumbnail': imgurl,
                'resAppEpisodes':episodes_num
            })
        page_list = []
        _RE_PAGE1 = re.compile(r'<div class="page">([\s\S]*?)</div>[\s\S]*?')
        _RE_PAGE2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
        for match in _RE_PAGE1.finditer(content):
            datapag =match.groups()[0]
            if _RE_PAGE2.search(str(datapag)):
                for match in _RE_PAGE2.finditer(str(datapag)):
                    match_page = match.groups('')[0]
                    page_list.append(match_page)
                maxpage = page_list[-2]
            else:
                maxpage= 1

    return items,maxpage

def buildNextLists(app_id,category_id,url,name,thumbnail,page,resappepisodes,medianame):
    resid = ""
    app_id = '49'
    more_url = url
    appspidername = 'qy'
    content = fetch_url(url)
    if page == "":
        page = "1"
    
    if category_id == "1":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_movie_from_url(content)
    elif category_id == "2":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_tv_from_url(content)
    elif category_id == "4":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_comic_from_url(content)
    elif category_id == "6":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_show_from_url(content)
    elif category_id == "7":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_fun_from_url(content)
    elif category_id == "16":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_micromovie_from_url(content)
    elif category_id == "15":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_kid_from_url(content)
    elif category_id == "3":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_recoder_from_url(content)
    elif category_id == "5":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_music_from_url(content)
    elif category_id == "13":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_style_from_url(content)
    elif category_id == "9":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_trip_from_url(content)
    elif category_id == "26":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_car_from_url(content)
    elif category_id == "12":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_educate_from_url(content)
    else:
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_other_from_url(content)

    episodesCount = resappepisodes_mf

    if category_id == "1" or category_id == '7' or category_id == '16' or category_id == '28' or category_id == '1007' or category_id == '1006' or category_id == '5' or category_id == '17' or category_id == '20' or category_id == '27' or category_id == '8' or category_id == '13' or category_id == '25' or category_id == '21' or category_id == '24' or category_id == '26' or category_id == '22':
        items,video_maxpage = get_video_juji_list(url,name)
    elif category_id == "2" or category_id == '4' or category_id == '15' or category_id == '12':
        items,video_maxpage = get_avlist_juji_list(content,page)
    elif category_id == '3' or category_id == '9':
        items,video_maxpage = get_sdvlst_juji_list(url,page,name)
    elif category_id == "6":
        items,video_maxpage = get_show_juji_list(content,page)

    for j in items:
        title = j["title"]
        play_url = j["url"]
        listitem=xbmcgui.ListItem(title)
        listitem.setProperty('name',title)
        listitem.setProperty('playurl',play_url)
        url=sys.argv[0] + '?mode=3&url=' + urllib.quote_plus(play_url)+ '&item_id='+'&app_id='+urllib.quote_plus(str(app_id))+'&appspidername='+urllib.quote_plus(appspidername)+'&name='+urllib.quote_plus(title)+'&resourceTitle='+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&page="+str(page)+'&category_id='+urllib.quote_plus(str(category_id))+"&view_mode="+urllib.quote_plus('morefunlist')
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, False)

    if (int(page) < int(video_maxpage)) and (category_id == "6" or category_id == '8' or category_id == '3' or category_id == '13' or category_id == '9' or category_id == '25' or category_id == '21' or category_id == '24' or category_id == '26' or category_id == '22' or category_id == '15' or category_id == '12' or 11<=int(page)):
        if len(items)>0:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' +'[/COLOR]',thumbnailImage=MORE_THUMB)
            listitem.setProperty('next','true')
            url=sys.argv[0]+'?mode=2&page='+str(int(page)+1) +'&category_id='+str(category_id)+ '&url=' + urllib.quote_plus(more_url)+ '&name=' + urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&resappepisodes="+urllib.quote_plus(resappepisodes)+ '&medianame='+urllib.quote_plus(medianame)
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
        else:
            plugin.notify('没有更多数据', delay=2000)
            return

    resappepisodes = resappepisodes.replace('更新至第','').replace('共','').replace('集全','').replace('集','')
    if resappepisodes.isdigit():
        if category_id == "2" or category_id == '4':
            maxpage = video_maxpage
            xbmcplugin.setProperty(int(sys.argv[1]), 'maxpage', str(maxpage))

    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunlist')
    xbmcplugin.setProperty(int(sys.argv[1]), 'title', name)
    xbmcplugin.setProperty(int(sys.argv[1]), 'areaname', areaname)
    xbmcplugin.setProperty(int(sys.argv[1]), 'stylename', stylename)
    xbmcplugin.setProperty(int(sys.argv[1]), 'year', year)
    xbmcplugin.setProperty(int(sys.argv[1]), 'actors', actors)
    xbmcplugin.setProperty(int(sys.argv[1]), 'description', description)
    xbmcplugin.setProperty(int(sys.argv[1]), 'resappepisodes', resappepisodes_mf)
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumbnail', thumbnail)

    if resid !="":
        xbmcplugin.setProperty(int(sys.argv[1]), 'itemId', 'qy'+str(resid))
        favouriteUrl = sys.argv[0]+"?fromtype=favourite&app_id=&resid="+urllib.quote_plus(str(resid))+"&page=&resappepisodes="+urllib.quote_plus(resappepisodes)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&category_id="+urllib.quote_plus(category_id)+"&url="+urllib.quote_plus(more_url)+"&title="+urllib.quote_plus(name)+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.setProperty(int(sys.argv[1]), 'url', favouriteUrl)

    xbmcplugin.setProperty(int(sys.argv[1]), 'itemType', 'iqiyi')
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumb', thumbnail)
    xbmcplugin.setProperty(int(sys.argv[1]), 'playable', 'false')
    xbmcplugin.setProperty(int(sys.argv[1]), 'morefuntvsource', "false")

    updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))+"&url="+urllib.quote_plus(more_url)+"&category_id="+urllib.quote_plus(category_id)+"&title="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)
    if (category_id == "2" or category_id == '4' or category_id == '12') and episodesCount != "":
        xbmcplugin.setProperty(int(sys.argv[1]), 'updateUrl', updateUrl)

    xbmcplugin.setProperty(int(sys.argv[1]), 'episodesNum', episodesCount)
    xbmcplugin.setProperty(int(sys.argv[1]), 'SencondFolder', medianame)

    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def get_detail_movie_from_url(content):
    _RE_resid = re.compile(r'albumId:([\s\S]*?),[\s\S]*?')
    for match in _RE_resid.finditer(content):
        resid = match.groups()[0]
        resid = str(resid).replace(' ', '')

    _RE_actor1 = re.compile(r'<!--主演信息start-->([\s\S]*?)<!--主演信息end-->[\s\S]*?')
    _RE_actor2 = re.compile(r'<meta itemprop="name" content="([\s\S]*?)"[\s\S]*?')
    if _RE_actor1.search(content):
        match = _RE_actor1.search(content)
        actors_data = match.groups()[0]
        actors = '/'
        for match in _RE_actor2.finditer(str(actors_data)):
            iteam = match.groups()[0]
            actors = actors + iteam + '/'
        actors = actors.strip('/') 
    else:
        actors = ''

    _RE_year = re.compile(r'rseat="time">发布时间：([\s\S]*?)</p>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''

    _RE_area = re.compile(r'<meta itemprop="contentLocation" content="([\s\S]*?)"[\s\S]*?')
    if _RE_area.search(content):
        match = _RE_area.search(content)
        areaname = match.groups()[0]
    else:
        areaname = ''
    
    _RE_type = re.compile(r'rseat="类型">类型：([\s\S]*?)</p>')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '').replace('|', '/')
    else:
        stylename = ''

    _RE_description = re.compile(r'rseat="subjian">([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    episodescount = "1"
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_tv_from_url(content):
    _RE_resid1 = re.compile(r'albumId:([\s\S]*?),[\s\S]*?')
    _RE_resid2 = re.compile(r'var albumInfo=[\s\S]*?"albumId":(\d*?),[\s\S]*?')
    if _RE_resid1.search(content):
        for match in _RE_resid1.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    else:
        for match in _RE_resid2.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    
    _RE_actor1 = re.compile(r'<!--主演信息start-->([\s\S]*?)<!--主演信息end-->[\s\S]*?')
    _RE_actor2 = re.compile(r'<meta itemprop="name" content="([\s\S]*?)"[\s\S]*?')
    _RE_actor3 = re.compile(r'<p>主演：([\s\S]*?)</p>[\s\S]*?')
    _RE_actor4 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_actor1.search(content):
        match = _RE_actor1.search(content)
        actors_data = match.groups()[0]
        actors = '/'
        for match in _RE_actor2.finditer(str(actors_data)):
            iteam = match.groups()[0]
            actors = actors + iteam + '/'
        actors = actors.strip('/')
    elif _RE_actor3.search(content):
        match = _RE_actor3.search(content)
        actors_data = match.groups()[0]
        actors = '/'
        for match in _RE_actor4.finditer(str(actors_data)):
            iteam = match.groups()[0]
            iteam = re.sub(r'（[\s\S]*?）','',iteam)
            actors = actors + iteam + '/'
        actors = actors.strip('/')
    else:
        actors = ''
    
    _RE_year1 = re.compile(r'rseat="time">发布时间：([\s\S]*?)</p>[\s\S]*?')
    _RE_year2 = re.compile(r'var albumInfo=[\s\S]*?"issueTime":([\s\S]*?),[\s\S]*?')
    if _RE_year1.search(content):
        match = _RE_year1.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    elif _RE_year2.search(content):
        match = _RE_year2.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '')
    else:
        year = ''
    
    _RE_type1 = re.compile(r'rseat="类型">类型：([\s\S]*?)</p>')
    _RE_type2 = re.compile(r'<p>类型：([\s\S]*?)</p>')
    _RE_type3 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '').replace('|', '/')
    elif _RE_type2.search(content):
        match = _RE_type2.search(content)
        type_data = match.groups()[0]
        stylename = '/'
        for match in _RE_type3.finditer(str(type_data)):
            iteam = match.groups()[0]
            if iteam:
                stylename = stylename + iteam + '/'
        stylename = stylename.strip('/')
    else:
        stylename = ''
    
    _RE_description1 = re.compile(r'rseat="subjian">([\s\S]*?)<[\s\S]*?')
    _RE_description2 = re.compile(r'<div id="j-album-less">([\s\S]*?)<[\s\S]*?')
    if _RE_description1.search(content):
        match = _RE_description1.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    elif _RE_description2.search(content):
        match = _RE_description2.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    areaname = ''
    episodescount = ''
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_comic_from_url(content):
    _RE_resid1 = re.compile(r'albumId:([\s\S]*?),[\s\S]*?')
    _RE_resid2 = re.compile(r'var albumInfo=[\s\S]*?"albumId":(\d*?),[\s\S]*?')
    if _RE_resid1.search(content):
        for match in _RE_resid1.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    else:
        for match in _RE_resid2.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    
    _RE_actor1 = re.compile(r'<p>主角：([\s\S]*?)</p>[\s\S]*?')
    _RE_actor2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_actor1.search(content):
        match = _RE_actor1.search(content)
        actors_data = match.groups()[0]
        actors = '/'
        for match in _RE_actor2.finditer(str(actors_data)):
            iteam = match.groups()[0]
            iteam = re.sub(r'（[\s\S]*?）','',iteam)
            actors = actors + iteam + '/'
        actors = actors.strip('/')
    else:
        actors = ''
    
    _RE_year1 = re.compile(r'rseat="time">发布时间：([\s\S]*?)</p>[\s\S]*?')
    _RE_year2 = re.compile(r'var albumInfo=[\s\S]*?"issueTime":([\s\S]*?),[\s\S]*?')
    if _RE_year1.search(content):
        match = _RE_year1.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    elif _RE_year2.search(content):
        match = _RE_year2.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '')
    else:
        year = ''
    
    _RE_type1 = re.compile(r'rseat="类型">类型：([\s\S]*?)</p>')
    _RE_type2 = re.compile(r'<p>标签：([\s\S]*?)</p>')
    _RE_type3 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '').replace('|', '/')
    elif _RE_type2.search(content):
        match = _RE_type2.search(content)
        type_data = match.groups()[0]
        stylename = '/'
        for match in _RE_type3.finditer(str(type_data)):
            iteam = match.groups()[0]
            if iteam:
                stylename = stylename + iteam + '/'
        stylename = stylename.strip('/')
    else:
        stylename = ''
    
    _RE_description1 = re.compile(r'rseat="subjian">([\s\S]*?)<[\s\S]*?')
    _RE_description2 = re.compile(r'<div id="j-album-less">([\s\S]*?)<[\s\S]*?')
    if _RE_description1.search(content):
        match = _RE_description1.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    elif _RE_description2.search(content):
        match = _RE_description2.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    areaname = ''
    episodescount = ''
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_show_from_url(content):
    _RE_resid = re.compile(r'albumId:([\s\S]*?),[\s\S]*?')
    if _RE_resid.search(content):
        for match in _RE_resid.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    
    _RE_actor1 = re.compile(r'rseat="主持人">主持人：([\s\S]*?)</p>[\s\S]*?')
    _RE_actor2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_actor1.search(content):
        match = _RE_actor1.search(content)
        actors_data = match.groups()[0]
        actors = '/'
        for match in _RE_actor2.finditer(str(actors_data)):
            iteam = match.groups()[0]
            actors = actors + iteam + '/'
        actors = actors.strip('/')
    else:
        actors = ''
    
    _RE_type = re.compile(r'rseat="类型">类型：([\s\S]*?)</p>')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '').replace('|', '/')
    else:
        stylename = ''
    
    _RE_year = re.compile(r'rseat="发布时间">发布时间：([\s\S]*?)</p>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    
    areaname = ''
    description = ''
    episodescount = ''
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_fun_from_url(content):
    _RE_resid = re.compile(r'albumId:([\s\S]*?),[\s\S]*?')
    if _RE_resid.search(content):
        match = _RE_resid.search(content)
        resid = match.groups()[0]
        resid = str(resid).replace(' ', '')
    else:
        resid = ''
    
    _RE_type = re.compile(r'<span id="widget-videotag" class="s-two" data-vi-elem="videotag">([\s\S]*?)</span>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''
    
    _RE_year = re.compile(r'<div class="explain-time">发布时间：<[\s\S]*?>([\s\S]*?)</span>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year =str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''
    
    _RE_description = re.compile(r'<div class="explain" id="widget-videodesc">[\s\S]*?<[\s\S]*?>([\s\S]*?)</div>[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    actors = ''
    areaname = ''
    episodescount = ''
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_micromovie_from_url(content):
    _RE_resid = re.compile(r'albumId:([\s\S]*?),[\s\S]*?')
    if _RE_resid.search(content):
        for match in _RE_resid.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    
    _RE_type = re.compile(r'rseat="类型">类型：([\s\S]*?)</p>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '').replace('|', '/')
    else:
        stylename = ''
    
    _RE_actor = re.compile(r'<div class="peos-info" id="widget-actor">([\s\S]*?)</div>[\s\S]*?')
    if _RE_actor.search(content):
        match = _RE_actor.search(content)
        actors = match.groups()[0]
        actors = re.sub('</a>','/',actors)
        actors =re.sub('<[\s\S]*?>','',actors)
        actors =str(actors).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        actors = ''
    
    _RE_year = re.compile(r'rseat="time">发布时间：([\s\S]*?)</p>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year =str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''
    
    _RE_description = re.compile(r'rseat="subjian">([\s\S]*?)</p>[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    areaname = ''
    episodescount = ''
    
    return resid,actors,stylename,areaname,year,description,episodescount



def get_detail_kid_from_url(content):
    _RE_resid1 = re.compile(r'albumId:([\s\S]*?),[\s\S]*?')
    _RE_resid2 = re.compile(r'var albumInfo=[\s\S]*?"albumId":(\d*?),[\s\S]*?')
    if _RE_resid1.search(content):
        for match in _RE_resid1.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    else:
        for match in _RE_resid2.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    
    _RE_year1 = re.compile(r'rseat="time">发布时间：([\s\S]*?)</p>[\s\S]*?')
    _RE_year2 = re.compile(r'var albumInfo=[\s\S]*?"issueTime":([\s\S]*?),[\s\S]*?')
    if _RE_year1.search(content):
        match = _RE_year1.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    elif _RE_year2.search(content):
        match = _RE_year2.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '')
    else:
        year = ''
    
    _RE_type1 = re.compile(r'rseat="类型">类型：([\s\S]*?)</p>')
    _RE_type2 = re.compile(r'<p>标签：([\s\S]*?)</p>')
    _RE_type3 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '').replace('|', '/')
    elif _RE_type2.search(content):
        match = _RE_type2.search(content)
        type_data = match.groups()[0]
        stylename = '/'
        for match in _RE_type3.finditer(str(type_data)):
            iteam = match.groups()[0]
            if iteam:
                stylename = stylename + iteam + '/'
        stylename = stylename.strip('/')
    else:
        stylename = ''
    
    _RE_description1 = re.compile(r'rseat="subjian">([\s\S]*?)<[\s\S]*?')
    _RE_description2 = re.compile(r'<div id="j-album-less">([\s\S]*?)<[\s\S]*?')
    if _RE_description1.search(content):
        match = _RE_description1.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    elif _RE_description2.search(content):
        match = _RE_description2.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    actors = ''
    areaname = ''
    episodescount = ''
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_recoder_from_url(content):
    _RE_resid1 = re.compile(r'albumId:([\s\S]*?),[\s\S]*?')
    _RE_resid2 = re.compile(r'var albumInfo=[\s\S]*?"albumId":(\d*?),[\s\S]*?')
    if _RE_resid1.search(content):
        for match in _RE_resid1.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    else:
        for match in _RE_resid2.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    
    _RE_year1 = re.compile(r'rseat="发布时间">发布时间：([\s\S]*?)</p>[\s\S]*?')
    _RE_year2 = re.compile(r'var albumInfo=[\s\S]*?"issueTime":([\s\S]*?),[\s\S]*?')
    if _RE_year1.search(content):
        match = _RE_year1.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    elif _RE_year2.search(content):
        match = _RE_year2.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '')
    else:
        year = ''
    
    _RE_type1 = re.compile(r'rseat="类型">类型：([\s\S]*?)</p>')
    _RE_type2 = re.compile(r'<p>标签：([\s\S]*?)</p>')
    _RE_type3 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '').replace('|', '/')
    elif _RE_type2.search(content):
        match = _RE_type2.search(content)
        type_data = match.groups()[0]
        stylename = '/'
        for match in _RE_type3.finditer(str(type_data)):
            iteam = match.groups()[0]
            if iteam:
                stylename = stylename + iteam + '/'
        stylename = stylename.strip('/')
    else:
        stylename = ''
    
    _RE_description1 = re.compile(r'<p id="data-videochange-desc"[\s\S]*?>([\s\S]*?)</p>[\s\S]*?')
    _RE_description2 = re.compile(r'<div id="j-album-less">([\s\S]*?)<[\s\S]*?')
    if _RE_description1.search(content):
        match = _RE_description1.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    elif _RE_description2.search(content):
        match = _RE_description2.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    actors = ''
    areaname = ''
    episodescount = ''
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_music_from_url(content):
    _RE_resid = re.compile(r'albumId:([\s\S]*?),[\s\S]*?')
    if _RE_resid.search(content):
        for match in _RE_resid.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    
    _RE_actor = re.compile(r'<li data-videoyulenewtag-tagtype="star">([\s\S]*?)</li>[\s\S]*?')
    actors = '/'
    if _RE_actor.search(content):
        for match in _RE_actor.finditer(content):
            iteam = match.groups()[0]
            iteam = re.sub('<[\s\S]*?>','',iteam)
            actors = actors + iteam + '/'
        actors = actors.strip('/')
    else:
        actors = ''
    
    _RE_year = re.compile(r'<span>发布时间：</span><span[\s\S]*?>([\s\S]*?)</span>')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''
    
    _RE_description = re.compile(r'<p data-videotvdesc-elem="label">([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description = str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    stylename = ''
    areaname = ''
    episodescount = ''
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_style_from_url(content):
    _RE_resid = re.compile(r'albumId:([\s\S]*?),[\s\S]*?')
    if _RE_resid.search(content):
        for match in _RE_resid.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    
    _RE_type1 = re.compile(r'rseat="类型">类型：([\s\S]*?)</p>[\s\S]*?')
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '').replace('|', '/')
    else:
        stylename = ''
    
    _RE_year1 = re.compile(r'rseat="发布时间">发布时间：([\s\S]*?)<[\s\S]*?')
    _RE_year2 = re.compile(r'<span>发布时间：</span><span[\s\S]*?>([\s\S]*?)</span>')
    if _RE_year1.search(content):
        match = _RE_year1.search(content)
        year = match.groups()[0]
        year =str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    elif _RE_year2.search(content):
        match = _RE_year2.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''
    
    _RE_description1 = re.compile(r'rseat="简介">简介：</p>[\s\S]*?<p[\s\S]*?>([\s\S]*?)<[\s\S]*?')
    _RE_description2 = re.compile(r'<p data-videotvdesc-elem="label">([\s\S]*?)<[\s\S]*?')
    if _RE_description1.search(content):
        match = _RE_description1.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    elif _RE_description2.search(content):
        match = _RE_description2.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    actors = ''
    areaname = ''
    episodescount = ''
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_trip_from_url(content):
    _RE_resid1 = re.compile(r'albumId:([\s\S]*?),[\s\S]*?')
    _RE_resid2 = re.compile(r'var albumInfo=[\s\S]*?"albumId":(\d*?),[\s\S]*?')
    if _RE_resid1.search(content):
        for match in _RE_resid1.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    else:
        for match in _RE_resid2.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    
    _RE_year1 = re.compile(r'rseat="发布时间">发布时间：([\s\S]*?)</p>[\s\S]*?')
    _RE_year2 = re.compile(r'var albumInfo=[\s\S]*?"issueTime":([\s\S]*?),[\s\S]*?')
    if _RE_year1.search(content):
        match = _RE_year1.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    elif _RE_year2.search(content):
        match = _RE_year2.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '')
    else:
        year = ''
    
    _RE_type1 = re.compile(r'rseat="类型">类型：([\s\S]*?)</p>')
    _RE_type2 = re.compile(r'<p class="twW50">\s*?标签：([\s\S]*?)</p>')
    _RE_type3 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '').replace('|', '/')
    elif _RE_type2.search(content):
        match = _RE_type2.search(content)
        type_data = match.groups()[0]
        stylename = '/'
        for match in _RE_type3.finditer(str(type_data)):
            iteam = match.groups()[0]
            if iteam:
                stylename = stylename + iteam + '/'
        stylename = stylename.strip('/')
    else:
        stylename = ''
    
    _RE_description = re.compile(r'<p class="twP">([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    actors = ''
    areaname = ''
    episodescount = ''
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_car_from_url(content):
    _RE_resid = re.compile(r'albumId:([\s\S]*?),[\s\S]*?')
    if _RE_resid.search(content):
        match = _RE_resid.search(content)
        resid = match.groups()[0]
        resid = str(resid).replace(' ', '')
    else:
        resid = ''
    
    _RE_type1 = re.compile(r'<span id="widget-videotag" class="s-two" data-vi-elem="videotag">([\s\S]*?)</span>[\s\S]*?')
    _RE_type2 = re.compile(r'<meta itemprop="genre" content="([\s\S]*?)"/>')
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    elif _RE_type2.search(content):
        stylename = '/'
        for match in _RE_type2.finditer(content):
            type = match.groups()[0]
            stylename = stylename + type + '/'
        stylename = stylename.strip('/')
    else:
        stylename = ''
    
    _RE_year = re.compile(r'<div class="explain-time">发布时间：<[\s\S]*?>([\s\S]*?)</span>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year =str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''
    
    _RE_description = re.compile(r'<div class="explain" id="widget-videodesc">[\s\S]*?<[\s\S]*?>([\s\S]*?)</div>[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    actors = ''
    areaname = ''
    episodescount = ''
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_educate_from_url(content):
    _RE_resid1 = re.compile(r'albumId:([\s\S]*?),[\s\S]*?')
    _RE_resid2 = re.compile(r'var albumInfo=[\s\S]*?"albumId":(\d*?),[\s\S]*?')
    if _RE_resid1.search(content):
        for match in _RE_resid1.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    else:
        for match in _RE_resid2.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    
    _RE_actor1 = re.compile(r'<div class="peos-info">([\s\S]*?)</div>[\s\S]*?')
    _RE_actor2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    _RE_actor3 = re.compile(r'<p>主讲老师：([\s\S]*?)</p>[\s\S]*?')
    _RE_actor4 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_actor1.search(content):
        match = _RE_actor1.search(content)
        actors_data = match.groups()[0]
        actors = '/'
        for match in _RE_actor2.finditer(str(actors_data)):
            iteam = match.groups()[0]
            actors = actors + iteam + '/'
        actors = actors.strip('/')
    elif _RE_actor3.search(content):
        match = _RE_actor3.search(content)
        actors_data = match.groups()[0]
        actors = '/'
        for match in _RE_actor4.finditer(str(actors_data)):
            iteam = match.groups()[0]
            iteam = re.sub(r'（[\s\S]*?）','',iteam)
            actors = actors + iteam + '/'
        actors = actors.strip('/')
    else:
        actors = ''
    
    _RE_year1 = re.compile(r'rseat="time">发布时间：([\s\S]*?)</p>[\s\S]*?')
    _RE_year2 = re.compile(r'var albumInfo=[\s\S]*?"issueTime":([\s\S]*?),[\s\S]*?')
    if _RE_year1.search(content):
        match = _RE_year1.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    elif _RE_year2.search(content):
        match = _RE_year2.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '')
    else:
        year = ''
    
    _RE_type1 = re.compile(r'rseat="类型">类型：([\s\S]*?)</p>')
    _RE_type2 = re.compile(r'<p>内容分类：([\s\S]*?)</p>')
    _RE_type3 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '').replace('|', '/')
    elif _RE_type2.search(content):
        match = _RE_type2.search(content)
        type_data = match.groups()[0]
        stylename = '/'
        for match in _RE_type3.finditer(str(type_data)):
            iteam = match.groups()[0]
            if iteam:
                stylename = stylename + iteam + '/'
        stylename = stylename.strip('/')
    else:
        stylename = ''
    
    _RE_description1 = re.compile(r'rseat="subjian">([\s\S]*?)<[\s\S]*?')
    _RE_description2 = re.compile(r'<div id="j-album-less">([\s\S]*?)<[\s\S]*?')
    if _RE_description1.search(content):
        match = _RE_description1.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    elif _RE_description2.search(content):
        match = _RE_description2.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    areaname = ''
    episodescount = ''
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_other_from_url(content):
    _RE_resid = re.compile(r'albumId:([\s\S]*?),[\s\S]*?')
    if _RE_resid.search(content):
        for match in _RE_resid.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    
    _RE_type1 = re.compile(r'rseat="类型">类型：([\s\S]*?)</p>[\s\S]*?')
    _RE_type2 = re.compile(r'<span id="widget-videotag" class="s-two" data-vi-elem="videotag">([\s\S]*?)</span>[\s\S]*?')
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '').replace('|', '/')
    elif _RE_type2.search(content):
        match = _RE_type2.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''
    
    _RE_year1 = re.compile(r'rseat="发布时间">发布时间：([\s\S]*?)<[\s\S]*?')
    _RE_year2 = re.compile(r'<div class="explain-time">发布时间：<[\s\S]*?>([\s\S]*?)</span>[\s\S]*?')
    if _RE_year1.search(content):
        match = _RE_year1.search(content)
        year = match.groups()[0]
        year =str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    elif _RE_year2.search(content):
        match = _RE_year2.search(content)
        year = match.groups()[0]
        year =str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''
    
    _RE_description1 = re.compile(r'rseat="简介">简介：</p>[\s\S]*?<p[\s\S]*?>([\s\S]*?)<[\s\S]*?')
    _RE_description2 = re.compile(r'<div class="explain" id="widget-videodesc">[\s\S]*?<[\s\S]*?>([\s\S]*?)</div>[\s\S]*?')
    if _RE_description1.search(content):
        match = _RE_description1.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    elif _RE_description2.search(content):
        match = _RE_description2.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    actors = ''
    areaname = ''
    episodescount = ''
    
    return resid,actors,stylename,areaname,year,description,episodescount


def get_video_juji_list(url,name):
    items = []
    items.append({'title': name,'url':url})
    return items,1

def get_avlist_juji_list(content,index):
    items = []
    ds_maxpage ='1'
    _RE_resid1 = re.compile(r'albumId:([\s\S]*?),[\s\S]*?')
    _RE_resid2 = re.compile(r'var albumInfo=[\s\S]*?"albumId":(\d*?),[\s\S]*?')
    if _RE_resid1.search(content):
        for match in _RE_resid1.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    else:
        for match in _RE_resid2.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
    pageNum=1
    has_next=True
    while has_next:
        detail_url = 'http://cache.video.qiyi.com/avlist/'+str(resid)+'/'+str(pageNum)+'/'
        plugin.log.debug('QQQQQQQQQQQQQQ'+detail_url)
        detail_content = fetch_url(detail_url)
        data = str(detail_content).replace('var videoListC=','')
        data = json.JSONDecoder().decode(data)
        iteam = []
        if 'data' in data.keys() and data["data"]["vlist"] != []:
            iteam = data["data"]["vlist"]
            pageNum = pageNum+1
            for i in range(len(iteam)):
                title = iteam[i]["vn"].encode('utf8')
                href = iteam[i]["vurl"].encode('utf8')
                items.append({'title': title,'url':href})
        else:
            has_next=False
    
    ds_maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if ds_maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    
    return items,ds_maxpage

def get_sdvlst_juji_list(url,index,name):
    items = []
    content = fetch_url(url)
    _RE = re.compile(r'<div id="j-tab-content">')
    if _RE.search(content):
        _RE_url = re.compile(r'<div id="j-album-\d*?" style="display: none;">([\s\S]*?)</div>')
        for match in _RE_url.finditer(content):
            url = match.groups()[0]
            detail_url = 'http://www.iqiyi.com'+str(url)
            detail_content = fetch_url(detail_url)
            _RE_detail = re.compile(r'<li>[\s\S]*?href="([\s\S]*?)"[\s\S]*?title="([\s\S]*?)"[\s\S]*?')
            for match in _RE_detail.finditer(detail_content):
                href,title = match.groups()
                items.append({'title': title,'url':href})
        
        ds_maxpage ='1'
        ds_maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
        detailpage = (int(index)-1)*100
        if ds_maxpage != index:
            items = items[detailpage:int(detailpage)+100]
        else:
            items = items[detailpage:len(items)]
    else:
        items.append({'title': name,'url':url})
        ds_maxpage ='1'
    
    return items,ds_maxpage

def get_show_juji_list(content,index):
    items = []
    ds_maxpage ='1'
    _RE_resid = re.compile(r'albumId:([\s\S]*?),[\s\S]*?')
    for match in _RE_resid.finditer(content):
        resid = match.groups()[0]
        resid = str(resid).replace(' ', '')
    detail_url = 'http://cache.video.qiyi.com/sdvlst/6/'+str(resid)+'/'
    detail_content = fetch_url(detail_url)
    data = str(detail_content).replace('var scDtVdListC=','')
    data = json.JSONDecoder().decode(data)
    iteam = []
    iteam = data["data"]
    for i in range(len(iteam)):
        title = iteam[i]["aName"].encode('utf8')
        href = iteam[i]["vUrl"].encode('utf8')
        items.append({'title': title,'url':href})
    
    ds_maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if ds_maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    
    return items,ds_maxpage


def playVideo(url):
    mylist = GetHttpData(url)
    foobars = re.compile('<m3u8>(.*?)</m3u8>', re.DOTALL).findall(mylist)
    playlist = xbmc.PlayList(1)
    playlist.clear()
    for i in range(0,len(foobars)):
        title =" 第"+str(i+1)+"/"+str(len(foobars))+"节"
        listitem=xbmcgui.ListItem(title)
        listitem.setInfo(type="Video",infoLabels={"Title":title})
        playlist.add(foobars[i], listitem)
    xbmc.Player().play(playlist)

def searchkey(category_id):
    keyword = ""
    type = ""
    if category_id == "1":
        category_mf = "1"
        keyword = "特殊身份,古惑仔,青春如期,小时代,狄仁杰之神都龙王,不二神探,激战,速度与激情"
        type = "电影"
    elif category_id == "2":
        category_mf = "2"
        keyword = "特种兵之火凤凰,因为爱情有多美,万万没想到,打狗棍,千金归来,法外风云,咱们结婚吧,终极一班3"
        type = "电视剧"
    elif category_id == "6":
        category_mf = "14"
        keyword = "爸爸去哪儿,快乐大本营,running man,康熙来了,晓说,天天向上,非诚勿扰,我们结婚了"
        type = "综艺"
    elif category_id == "4":
        category_mf = "4"
        keyword = "灌篮高手,火影忍者,熊出没,奥特曼,名侦探柯南,海贼王,尸兄,我叫mt"
        type = "动漫"
    kb = Keyboard('','请输入搜索内容',keyword,type)
    kb.doModal()
    if (kb.isConfirmed()):
        keyword = kb.getText()
        if keyword !='':
            searchpage = 1
            searchlist(keyword,category_id,category_mf,searchpage)
        else:
            xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
            xbmcplugin.endOfDirectory(int(sys.argv[1]))
    else:
        xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
        xbmcplugin.endOfDirectory(int(sys.argv[1]))
    
def searchlist(keyword,category_id,category_mf,searchpage):
    search_path = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/search/"+keyword+"?page_size=54"+"&page_no="+str(searchpage)+"&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1383555354&security_code=ce30ea919afcc8cf731b5edf8f91ee6c&session_id=dltianwei&category_id="+str(category_mf)+"&app_id=49"
    search_path = eval(repr(search_path).replace("\\x","%"))
    p1 = GetHttpData(search_path)
    data = json.JSONDecoder().decode(p1)
    newses = data["data"]
    app_id = ''
    area_id = ''
    style_id = ''
    if newses != None:
        newses1 = newses["items"]
        maxpage = newses["totalPages"]
        for i in newses1:
            name = i["title"].encode("utf-8")
            resid = i["id"]
            resappepisodes = i["resAppEpisodes"]
            url = i["channelUrl"]
            thumbnail = i["thumbnail"].encode("utf-8")
            listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
            u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url)+"&name="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+'&category_id='+urllib.quote_plus(category_id)+'&resappepisodes='+urllib.quote_plus(str(resappepisodes))
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(newses1))
        if int(maxpage) > searchpage:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' + str(searchpage) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=MORE_THUMB)
            listitem.setProperty('next','true')
            u=sys.argv[0] + '?mode=9&mfcachetype=dir_cache_always&searchpage='+str(searchpage+1) +'&app_id='+urllib.quote_plus('0')+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&keyword=' + urllib.quote_plus(keyword)+"&view_mode="+urllib.quote_plus('morefunthumb')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getareas(category, category_id,medianame):
    areas = []
    if category == "movie":
        areas = movie_areas
    elif category == "tv":
        areas = tv_areas
    elif category == "show":
        areas = show_areas
    elif category == "comic":
        areas = comic_areas
    elif category == "fun":
        areas = fun_areas
    elif category == "kid":
        areas = kid_areas
    elif category == "music":
        areas = music_areas
    elif category == "trip":
        areas = trip_areas
    elif category == "life":
        areas = life_areas
    elif category == "car":
        areas = car_areas
    elif category == "jock":
        areas = jock_areas
    elif category == "ad":
        areas = ad_areas
    elif category == "tit_movie":
        areas = tit_movie_areas
    elif category == "tit_tv":
        areas = tit_tv_areas
    elif category == "micromovie" or category == "games" or category == "war" or category == "recoder" or category == "sport" or category == "style" or category == "info" or category == "business" or category == "educate" or category == "creation":
        areas = void_areas
    for area in areas:
        listitem=xbmcgui.ListItem(area[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&name="+urllib.quote_plus(area[0])+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus(area[1])+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getstyles(category, category_id,medianame):
    styles = []
    if category == "movie":
        styles = movie_styles
    elif category == "tv":
        styles = tv_styles
    elif category == "show":
        styles = show_styles
    elif category == "comic":
        styles = comic_styles
    elif category == "fun":
        styles = fun_styles
    elif category == "micromovie":
        styles = micromovie_styles
    elif category == "games":
        styles = games_styles
    elif category == "kid":
        styles = kid_styles
    elif category == "war":
        styles = war_styles
    elif category == "recoder":
        styles = recoder_styles
    elif category == "music":
        styles = music_styles
    elif category == "sport":
        styles = sport_styles
    elif category == "style":
        styles = style_styles
    elif category == "trip":
        styles = trip_styles
    elif category == "info":
        styles = info_styles
    elif category == "life":
        styles = life_styles
    elif category == "business":
        styles = business_styles
    elif category == "car":
        styles = car_styles
    elif category == "jock":
        styles = jock_styles
    elif category == "ad":
        styles = ad_styles
    elif category == "educate":
        styles = educate_styles
    elif category == "creation":
        styles = creation_styles
    elif category == "tit_movie":
        styles = tit_movie_styles
    elif category == "tit_tv":
        styles = tit_tv_styles
    for style in styles:
        listitem=xbmcgui.ListItem(style[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&name="+urllib.quote_plus(style[0])+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus(style[1])+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getyears(category,category_id,medianame):
    years = []
    if category == "movie" or category == "tv":
        years = full_years
    else:
        years = void_years
    for year in years:
        listitem=xbmcgui.ListItem(year[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&name="+urllib.quote_plus(year[0])+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus(year[1])+"&released_on_to="+urllib.quote_plus(year[2])+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def display_for_history(params):
    app_id = urllib.unquote_plus(params['app_id']) if 'app_id' in params else ''
    category_id = urllib.unquote_plus(params['category_id']) if 'category_id' in params else ''
    url = urllib.unquote_plus(params['url']) if 'url' in params else ''
    name = urllib.unquote_plus(params['title']) if 'title' in params else ''
    if name == "" or name == None:
        name = urllib.unquote_plus(params['name']) if 'name' in params else ''
    page = urllib.unquote_plus(params['page']) if 'page' in params else ''
    resappepisodes = urllib.unquote_plus(params['resappepisodes']) if 'resappepisodes' in params else ''
    thumbnail = urllib.unquote_plus(params['thumbnail']) if 'thumbnail' in params else ''
    medianame = urllib.unquote_plus(params['medianame']) if 'medianame' in params else ''
    buildNextLists(app_id,category_id,url,name,thumbnail,page,resappepisodes,medianame)

def display_for_favourite(params):
    display_for_history(params)

def update_favourite(params):
    title = urllib.unquote_plus(params['title']) if 'title' in params else ''
    thumbnail = urllib.unquote_plus(params['thumbnail']) if 'thumbnail' in params else ''
    resid = urllib.unquote_plus(params['resid']) if 'resid' in params else ''
    url = urllib.unquote_plus(params['url']) if 'url' in params else ''
    category_id = urllib.unquote_plus(params['category_id']) if 'category_id' in params else ''
    content = fetch_url(url)
    
    if category_id == "1":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_movie_from_url(content)
    elif category_id == "2":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_tv_from_url(content)
    elif category_id == "4":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_comic_from_url(content)
    elif category_id == "6":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_show_from_url(content)
    elif category_id == "7":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_fun_from_url(content)
    elif category_id == "16":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_micromovie_from_url(content)
    elif category_id == "15":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_kid_from_url(content)
    elif category_id == "3":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_recoder_from_url(content)
    elif category_id == "5":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_music_from_url(content)
    elif category_id == "13":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_style_from_url(content)
    elif category_id == "9":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_trip_from_url(content)
    elif category_id == "26":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_car_from_url(content)
    elif category_id == "12":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_educate_from_url(content)
    elif category_id == "27":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_creation_from_url(content)
    elif category_id == "8" or category_id == '28' or category_id == '17' or category_id == '25' or category_id == '21' or category_id == '24' or category_id == '22' or category_id == '20' or category_id == '1007' or category_id == '1006':
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_other_from_url(content)

    episodesCount = resappepisodes_mf
    
    updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))+"&url="+urllib.quote_plus(url)+"&category_id="+urllib.quote_plus(category_id)
    listitem=xbmcgui.ListItem(title)
    listitem.setProperty('title',title)
    listitem.setProperty('thumb',thumbnail)
    listitem.setProperty('episodesNum',episodesCount)
    listitem.setProperty('updateUrl',updateUrl)
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), updateUrl, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))


def get_params(url = ''):
    param = []
    paramstring = sys.argv[2] if url=='' else url
    if len(paramstring) >= 2:
        params = paramstring
        cleanedparams = params.replace('?', '')
        if (params[len(params) - 1] == '/'):
            params = params[0:len(params) - 2]
        pairsofparams = cleanedparams.split('&')
        param = {}
        for i in range(len(pairsofparams)):
            splitparams = {}
            splitparams = pairsofparams[i].split('=')
            if (len(splitparams)) == 2:
                param[splitparams[0]] = splitparams[1]
    return param

 