# -*- coding: utf-8 -*-
# default.py

import urllib,urllib2,re,xbmcplugin,xbmcgui,subprocess,sys,os,os.path,xbmcaddon


# Plugin constants 
__addonid__ = "plugin.video.mflive"
__addon__ = xbmcaddon.Addon(id=__addonid__)
__cwd__ = __addon__.getAddonInfo('path')
__resource__  = xbmc.translatePath( os.path.join( __cwd__, 'lib' ) ).decode("utf-8")
sys.path.append (__resource__)
import getlist
from customchannels import customChannels
import itvi_play

def playVideo(app_id,url,name,resid,is_custom):
    urls = url.split(",")
    source_ids = app_id.split(",")
    if not is_custom == 'true':
        customUrls = customChannels.getChannelUrl(name)
        for url in customUrls:
            urls.append(url)
            source_ids.append('0')
    if(len(urls) > 0):
        playlist = xbmc.PlayList(1)
        playlist.clear()
        for i in range(0,len(urls)):
            title =name+" 第"+str(i+1)+"/"+str(len(urls))+"个源"
            listitem=xbmcgui.ListItem(title)
            listitem.setInfo(type="Video", infoLabels={'Title':title,'status':'livetv'})
            
            listitem.setProperty("needgetreal","true")
            listitem.setProperty("resId",str(resid))
            
            if i < len(source_ids):
                listitem.setProperty("source_id",source_ids[i])
            else:
                listitem.setProperty("source_id","0")
                
            listitem.setProperty("url",urls[i].replace('*&&*',','))
            listitem.setProperty("source_kind","TvAreaChannel")
            listitem.setProperty("methodName","AnalysisRealUrlForMorefun")
            listitem.setProperty("spiderName","")
            listitem.setProperty("videoParam","")
            listitem.setProperty("itemId","")
            listitem.setProperty("dflag","")
            listitem.setProperty('playerRequired',"dvdplayer")
            if(i < len(urls)-1):
                listitem.setProperty("IsLastOneItem","false")
            else:
                listitem.setProperty("IsLastOneItem","true")
            playlist.add(urls[i].replace('*&&*',','), listitem)
    xbmc.Player().play(playlist)
    
params = getlist.get_params()
mode = None
url = None
page = None
type = None

app_id = ''
category_id = '1'
area_id = ''
style_id = ''
released_on_from = ''
released_on_to = ''
page_size = ''
resid = ''
channelurl = ''
name = ''
customsource = ''
is_custom = ''
description = ''

try:
    url = urllib.unquote_plus(params["url"])
except:
    pass
try:
    mode = int(params["mode"])
except:
    pass
try:
    page = int(params["page"])
except:
    pass
try:
    type = int(params["type"])
except:
    pass
try:
    app_id = urllib.unquote_plus(params["app_id"])
except:
    pass
try:
    category_id = int(params["category_id"])
except:
    pass
try:
    area_id = urllib.unquote_plus(params["area_id"])
    if area_id == "0":
        area_id = ""
except:
    pass
try:
    style_id = urllib.unquote_plus(params["style_id"])
    if style_id == "0":
        style_id = ""
except:
    pass
try:
    released_on_from = urllib.unquote_plus(params["released_on_from"])
    if released_on_from == "0":
        released_on_from = ""
except:
    pass
try:
    released_on_to = urllib.unquote_plus(params["released_on_to"])
    if released_on_to == "0":
        released_on_to = ""
except:
    pass
try:
    page_size = int(params["page_size"])
except:
    pass
try:
    resid = urllib.unquote_plus(params["resid"])
except:
    pass
try:
    channelurl = urllib.unquote_plus(params["channelurl"])
except:
    pass
try:
    name = urllib.unquote_plus(params["name"])
except:
    pass
try:
    customsource = urllib.unquote_plus(params["customsource"])
except:
    pass

try:
    is_custom = urllib.unquote_plus(params["is_custom"])
except:
    pass
    
try:
    description = urllib.unquote_plus(params["description"])
except:
    pass

if mode == None:
    getlist.buildRoot()
elif mode == 1:
    getlist.buildLists(app_id,category_id,area_id,url,page,style_id)
elif mode == 2:
    getlist.buildNextLists(url,app_id,resid)
elif mode == 3:
    if description=='worldcupvod':
        properties = {}
        properties['itemType'] = 'morefun'
        properties['sourceId'] = app_id
        properties['url'] = channelurl.replace('*&&*',',')
        properties['sourceKind'] = ''
        properties['itemId'] = resid
        properties['spiderName'] = ''
        properties['videoParam'] = ''
        properties['title'] = name
        properties['resourceTitle'] = ''
        properties['thumb'] = ''
        properties['saveHistory'] = 'false'
        player = itvi_play.ItviItemPlayer()
        player.play(properties)
    else:
        playVideo(app_id,channelurl,name,resid,is_custom)
elif mode == 4:
    getlist.setarea()
elif mode == 5:
    getlist.performChange(app_id,category_id,url)
elif mode == 6:
    getlist.setres(url,resid)
elif mode == 11:
    getlist.buildCustomChannelList(customsource)
elif mode == 12:
    getlist.buildCustomManageList()
elif mode == 13:
    getlist.importCustomChannels()
elif mode == 14:
    getlist.removeCustomChannels(customsource)
