# -*- coding: utf-8 -*-
# getlist.py

import urllib,urllib2,re,xbmcplugin,xbmcgui,subprocess,sys,os,os.path,xbmcaddon,md5,hashlib,xbmc   
import json
try:
    from MFSearchKeyboard import Keyboard
except:
    from xbmc import Keyboard
    pass
from xbmcswift2 import Plugin
plugin = Plugin()
__addonid__ = "plugin.video.mfsearch"
__addon__ = xbmcaddon.Addon(id=__addonid__)
RESOURCES_PATH = os.path.join(__addon__.getAddonInfo('path'), 'media', )
more = os.path.join(RESOURCES_PATH,'more.png')
paging = os.path.join(RESOURCES_PATH,'paging.png')
china = os.path.join(RESOURCES_PATH,'china.png')
japan = os.path.join(RESOURCES_PATH,'japan.png')
korea = os.path.join(RESOURCES_PATH,'korea.png')
usa = os.path.join(RESOURCES_PATH,'usa.png')
other = os.path.join(RESOURCES_PATH,'other.png')
search_icon = os.path.join(RESOURCES_PATH,'search_icon.png')

def GetHttpData(url):
    #UserAgent = ''
    req = urllib2.Request(url)
    #req.add_header('User-Agent', UserAgent)
    response = urllib2.urlopen(req)
    httpdata = response.read()
    if response.headers.get('content-encoding', None) == 'gzip':
        httpdata = gzip.GzipFile(fileobj=StringIO.StringIO(httpdata)).read()
    response.close()
    match = re.compile('encodingt=(.+?)"').findall(httpdata)
    if len(match)<=0:
        match = re.compile('meta charset="(.+?)"').findall(httpdata)
    if len(match)>0:
        charset = match[0].lower()
        if (charset != 'utf-8') and (charset != 'utf8'):
            httpdata = unicode(httpdata, charset).encode('utf8')
    return httpdata

def buildRoot():
    
    listitem=xbmcgui.ListItem('搜索',thumbnailImage=search_icon)
    url=sys.argv[0]+"?mode=8&name="+urllib.quote_plus('搜索')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('0')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('45')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&view_mode="+urllib.quote_plus('morefunthumb')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def buildLists(app_id,category_id,area_id,url,page,style_id):
    #"http://api.cube.morefun.tv/cube/api/resources?app_id=527&client_id=206&page_size=50&client_id=206&user_type=1&user_id=0&timestamp=1384222167&security_code=a7ec99db65f88412bc035daef0e2b781&session_id=dltianwei"
    url1 = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources?app_id=527&page_no="+str(page)+"&page_size=45&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
    p1 = GetHttpData(url1)
    data = json.JSONDecoder().decode(p1)
    newses = data["data"]
    if newses != None:
        newses1 = newses["items"]
        maxpage = newses["totalPages"]
        #if page > 1:
            #listitem=xbmcgui.ListItem('[COLOR FF004AFF]上一页  ' + str(page)+ '/' +str(maxpage) +'[/COLOR]',thumbnailImage=paging)
            #listitem.setProperty('previous','true')
            #u=sys.argv[0] + '?mode=1&mfcachetype=dir_cache_always&page='+str(page-1) +'&app_id='+urllib.quote_plus(str(app_id))+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&url=' + urllib.quote_plus(url1)+"&view_mode="+urllib.quote_plus('morefunthumb')
            #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
        for i in newses1:
            name = i["title"].encode("utf-8")
            resid = i["id"]
            resappepisodes = i["resAppEpisodes"]
            url = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/"+str(resid)+"?page_size=45&app_id=&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
            thumbnail = i["thumbnail"].encode("utf-8")
            listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
            listitem.setProperty('resappepisodes',str(resappepisodes))
            u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url) +'&app_id='+urllib.quote_plus(str(app_id))+'&resid='+str(resid)+"&resappepisodes="+urllib.quote_plus(str(resappepisodes))+"&thumbnail="+urllib.quote_plus(thumbnail)+"&view_mode="+urllib.quote_plus('morefunthumbhomesearch')+'&need_type='+urllib.quote_plus('source')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(newses1))
        #if int(maxpage) > page:
            #listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' + str(page) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=more)
            #listitem.setProperty('next','true')
            #u=sys.argv[0] + '?mode=1&mfcachetype=dir_cache_always&page='+str(page+1) +'&app_id='+urllib.quote_plus(str(app_id))+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&url=' + urllib.quote_plus(url1)+"&view_mode="+urllib.quote_plus('morefunthumb')
            #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbhomesearch')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def buildNextLists(url,app_id,resid,page,resappepisodes,thumbnail):
    styleurl = xbmc.getInfoLabel("AppServer.IP") + "/cube/api/resources/"+str(resid)+"?page_size=100&app_id=" + str(app_id) +"&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
    plugin.log.debug('wwwww'+styleurl)
    stylelist = GetHttpData(styleurl)
    styledata = json.JSONDecoder().decode(stylelist)
    styleurls = styledata["data"]
    appidlist = styleurls["appId"].encode("utf-8")
    sourceNamelist = styleurls["sourceName"].encode("utf-8")
    applist = appidlist.split(",")
    sourcelist = sourceNamelist.split(",")
    if app_id =="":
        app_id = applist[0]
    newappidlist = ';'
    newappnamelist = ';'
    for id in applist:
        newappidlist = newappidlist + id + ';'
    for name in sourcelist:
        newappnamelist = newappnamelist + name + ';'
    title = styleurls["title"].encode("utf-8")
    areaname = styleurls["areaName"].encode("utf-8")
    stylename = styleurls["styleName"].encode("utf-8")
    year = str(styleurls["releasedOn"]).split("-")[0]
    actors = styleurls["actors"].encode("utf-8")
    description = styleurls["description"].encode("utf-8")
    episodesCount = str(styleurls["episodesCount"]) if "episodesCount" in styleurls else ''
    url = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/"+str(resid)+"/episodes?"+"page_size=100&app_id="+str(app_id)+"&page_no="+str(page)+"&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
    mylist = GetHttpData(url)
    data1 = json.JSONDecoder().decode(mylist)
    urls = data1["data"]
    urls1 = urls["items"]
    maxpage = urls["totalPages"]
    #if page > 1:
        #listitem=xbmcgui.ListItem('[COLOR FF004AFF]上一页  ' + str(page)+ '/' +str(maxpage) +'[/COLOR]')
        #u=sys.argv[0] + '?mode=2&mfcachetype=dir_cache_always&page='+str(page-1) +'&app_id='+urllib.quote_plus(str(app_id))+'&resid='+str(resid)+ '&url=' + urllib.quote_plus(url)
        #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    for j in urls1:
        item_id = j["id"]
        name = j["title"].encode("utf-8")
        play_url = j["playUrl"].encode("utf-8")
        appspidername = j["appSpiderName"].encode("utf-8")
        listitem=xbmcgui.ListItem(name)
        listitem.setProperty('name',name)
        listitem.setProperty('playurl',play_url)
        #listitem.setProperty('appidlist',newappidlist)
        #listitem.setProperty('maxpage',str(maxpage))
        url=sys.argv[0] + '?mode=3&mfcachetype=dir_cache_always&url=' + urllib.quote_plus(play_url)+ '&item_id=' + str(item_id)+'&app_id='+urllib.quote_plus(str(app_id))+'&appspidername='+urllib.quote_plus(appspidername)+'&name='+urllib.quote_plus(name)+'&resourceTitle='+urllib.quote_plus(title)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&view_mode="+urllib.quote_plus('morefunlist')
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, False)
    #if int(maxpage) > page:
        #listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' + str(page) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=more)
        #u=sys.argv[0] + '?mode=2&mfcachetype=dir_cache_always&page='+str(page+1) +'&app_id='+urllib.quote_plus(str(app_id))+'&resid='+str(resid)+ '&url=' + urllib.quote_plus(url)
        #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    #if not int(maxpage) == 1:
        #listitem=xbmcgui.ListItem('[COLOR FF004AFF]选择页数[/COLOR]',thumbnailImage=paging)
        #u=sys.argv[0] + '?mode=7&maxpage='+str(maxpage) +'&app_id='+urllib.quote_plus(str(app_id))+'&resid='+str(resid)+ '&url=' + urllib.quote_plus(url)
        #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunlist')
    xbmcplugin.setProperty(int(sys.argv[1]), 'title', title)
    xbmcplugin.setProperty(int(sys.argv[1]), 'areaname', areaname)
    xbmcplugin.setProperty(int(sys.argv[1]), 'stylename', stylename)
    xbmcplugin.setProperty(int(sys.argv[1]), 'year', year)
    xbmcplugin.setProperty(int(sys.argv[1]), 'actors', actors)
    xbmcplugin.setProperty(int(sys.argv[1]), 'description', description)
    xbmcplugin.setProperty(int(sys.argv[1]), 'appidlist', newappidlist)
    xbmcplugin.setProperty(int(sys.argv[1]), 'appnamelist', newappnamelist)
    xbmcplugin.setProperty(int(sys.argv[1]), 'app_id', app_id)
    xbmcplugin.setProperty(int(sys.argv[1]), 'resappepisodes', resappepisodes)
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumbnail', thumbnail)
    xbmcplugin.setProperty(int(sys.argv[1]), 'maxpage', str(maxpage))
    
    xbmcplugin.setProperty(int(sys.argv[1]), 'itemId', 'morefun'+str(resid))
    xbmcplugin.setProperty(int(sys.argv[1]), 'itemType', 'morefun')
    favouriteUrl = sys.argv[0]+"?fromtype=favourite&app_id=&resid="+urllib.quote_plus(str(resid))+"&page=&resappepisodes="+urllib.quote_plus(resappepisodes)+"&thumbnail="+urllib.quote_plus(thumbnail)+'&need_type='+urllib.quote_plus('source')
    xbmcplugin.setProperty(int(sys.argv[1]), 'url', favouriteUrl)
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumb', thumbnail)
    xbmcplugin.setProperty(int(sys.argv[1]), 'playable', 'false')
    updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))
    xbmcplugin.setProperty(int(sys.argv[1]), 'updateUrl', updateUrl)
    xbmcplugin.setProperty(int(sys.argv[1]), 'episodesNum', episodesCount)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))
        
def playVideo(url):
    mylist = GetHttpData(url)
    foobars = re.compile('<m3u8>(.*?)</m3u8>', re.DOTALL).findall(mylist)
    playlist = xbmc.PlayList(1)
    playlist.clear()
    for i in range(0,len(foobars)):
        title =" 第"+str(i+1)+"/"+str(len(foobars))+"节"
        listitem=xbmcgui.ListItem(title)
        listitem.setInfo(type="Video",infoLabels={"Title":title})
        playlist.add(foobars[i], listitem)
    xbmc.Player().play(playlist)

def selectpage(url,app_id,resid,maxpage,resappepisodes,thumbnail):
    maxpages = []
    for i in range(1, maxpage+1):
        maxpages.append(str(i))
    dialog = xbmcgui.Dialog()
    sel = dialog.select('选择页数', maxpages)
    if sel != -1:
        page=maxpages[sel]
        buildNextLists(url,app_id,resid,int(page),resappepisodes,thumbnail)
        

def searchkey(category_id):
    keyword = "澳门风云,一仆二主,僵尸,叛逃,屌丝男士,来自星星的你,行尸走肉,我是歌手,快乐大本营,熊出没"
    type = ""
    kb = Keyboard('','请输入搜索内容',keyword,type)
    kb.doModal()
    if (kb.isConfirmed()):
        keyword = kb.getText()
        if keyword !='':
            searchpage = 1
            searchlist(keyword,category_id,searchpage)
            #listitem=xbmcgui.ListItem('',thumbnailImage='')
            #u=sys.argv[0] + '?mode=9&category_id='+str(category_id) +'&keyword='+urllib.quote_plus(keyword)+'&searchpage='+str(searchpage)
            #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
            #xbmcplugin.endOfDirectory(int(sys.argv[1]))
            #xbmcplugin.addSortMethod(int(sys.argv[1]), 9)
        else:
            xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
            xbmcplugin.endOfDirectory(int(sys.argv[1]))
    else:
        xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
        xbmcplugin.endOfDirectory(int(sys.argv[1]))
    
def searchlist(keyword,category_id,searchpage):
    search_path = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/search/"+keyword+"?page_size=45"+"&page_no="+str(searchpage)+"&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1383555354&security_code=ce30ea919afcc8cf731b5edf8f91ee6c&session_id=dltianwei&category_id="+str(category_id)
    search_path = eval(repr(search_path).replace("\\x","%"))
    p1 = GetHttpData(search_path)
    data = json.JSONDecoder().decode(p1)
    newses = data["data"]
    app_id = ''
    area_id = ''
    style_id = ''
    if newses != None:
        newses1 = newses["items"]
        maxpage = newses["totalPages"]
        #if page > 1:
            #listitem=xbmcgui.ListItem('[COLOR FF004AFF]上一页  ' + str(page)+ '/' +str(maxpage) +'[/COLOR]',thumbnailImage=paging)
            #listitem.setProperty('previous','true')
            #u=sys.argv[0] + '?mode=1&mfcachetype=dir_cache_always&page='+str(page-1) +'&app_id='+urllib.quote_plus(str(app_id))+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&url=' + urllib.quote_plus(url1)+"&view_mode="+urllib.quote_plus('morefunthumb')
            #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
        for i in newses1:
            name = i["title"].encode("utf-8") if "title" in i and i["title"] else ""
            resid = i["id"]  if "id" in i and i["id"] else ""
            resappepisodes = i["resAppEpisodes"]  if "resAppEpisodes" in i and i["resAppEpisodes"] else ""
            url = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/"+str(resid)+"?page_size=50&app_id=&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
            thumbnail = i["thumbnail"].encode("utf-8")  if "thumbnail" in i and i["thumbnail"] else ""
            listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
            #listitem.setProperty('resappepisodes',str(resappepisodes))
            #listitem.setProperty('keyword',str(keyword))
            u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url)+'&keyword='+urllib.quote_plus(keyword)+'&app_id='+urllib.quote_plus(str(app_id))+'&resid='+str(resid)+"&resappepisodes="+urllib.quote_plus(str(resappepisodes))+"&thumbnail="+urllib.quote_plus(thumbnail)+"&view_mode="+urllib.quote_plus('morefunthumbsearch')+'&need_type='+urllib.quote_plus('source')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(newses1))
        if int(maxpage) > searchpage:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' + str(searchpage) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=more)
            listitem.setProperty('next','true')
            u=sys.argv[0] + '?mode=9&mfcachetype=dir_cache_always&searchpage='+str(searchpage+1) +'&app_id='+urllib.quote_plus('0')+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&keyword=' + urllib.quote_plus(keyword)+"&view_mode="+urllib.quote_plus('morefunthumbsearch')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
        #elif maxpage == 0:
            #listitem=xbmcgui.ListItem('[COLOR FF004AFF]无数据  [/COLOR]',thumbnailImage="")
            #u=sys.argv[0] + '?mode=9&searchpage=' + str(searchpage)+"&view_mode="+urllib.quote_plus('morefunthumb')
            #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
    xbmcplugin.setProperty(int(sys.argv[1]),'keyword',str(keyword))
    xbmcplugin.endOfDirectory(int(sys.argv[1]))



def performChange(app_id,category_id,url):
    typeid = [1,2,3,5,6]
    typename = ["喜剧","动作","惊悚","科幻","爱情"]
    dialog = xbmcgui.Dialog()
    sel = dialog.select('选择分类', typename)
    page = 1
    if sel != -1:
        style_id=typeid[sel]
        buildLists(app_id,category_id,area_id,url,page,style_id)

def getsources(appidlist,appnamelist):
    appidlist = appidlist.strip(';')
    appidlist = appidlist.split(";")
    sourcelist = []
    if appnamelist=='':
        for id in appidlist:
            for i in sources:
                if id == i[1]:
                    sourcelist.append({'source': i[2], 'sourceid': id})
        for j in sourcelist:
            listitem=xbmcgui.ListItem(j["source"],thumbnailImage="")
            listitem.setProperty('app_id', j["sourceid"])
            url= ''
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
        xbmcplugin.endOfDirectory(int(sys.argv[1]))
    else:
        appnamelist = appnamelist.strip(';')
        appnamelist = appnamelist.split(';')
        for i in range(len(appidlist)):
            sourcelist.append({'source': appnamelist[i], 'sourceid': appidlist[i]})
        for j in sourcelist:
            listitem=xbmcgui.ListItem(j["source"],thumbnailImage="")
            listitem.setProperty('app_id', j["sourceid"])
            url= ''
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
        xbmcplugin.endOfDirectory(int(sys.argv[1]))

def setres(url,resid,resappepisodes,thumbnail):
    mylist = GetHttpData(url)
    data1 = json.JSONDecoder().decode(mylist)
    urls = data1["data"]
    appid = urls["appId"]
    appname = urls["appName"].encode("utf-8")
    applist = appid.split(",")
    appnamelist = appname.split(",")
    page = 1
    if len(applist) > 1:
        dialog = xbmcgui.Dialog()
        sel = dialog.select('选择数据源', appnamelist)
        if sel != -1:
            app_id=applist[sel]
            buildNextLists(url,app_id,resid,page,resappepisodes,thumbnail)
    else:
        app_id=applist[0]
        buildNextLists(url,app_id,resid,page,resappepisodes,thumbnail)
    
def setarea():
    listitem=xbmcgui.ListItem('大陆')
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('大陆')+"&area_id="+urllib.quote_plus('2')+"&view_mode="+urllib.quote_plus('morefunthumb')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('港台')
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('港台')+"&area_id="+urllib.quote_plus('1,9,18')+"&view_mode="+urllib.quote_plus('morefunthumb')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('日韩')
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('日韩')+"&area_id="+urllib.quote_plus('3,6,17')+"&view_mode="+urllib.quote_plus('morefunthumb')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('欧美')
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('欧美')+"&area_id="+urllib.quote_plus('4,16,50')+"&view_mode="+urllib.quote_plus('morefunthumb')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))
    
def display_for_history(params):
    app_id = urllib.unquote_plus(params['app_id']) if 'app_id' in params else ''
    resid = urllib.unquote_plus(params['resid']) if 'resid' in params else ''
    page = urllib.unquote_plus(params['page']) if 'page' in params else ''
    resappepisodes = urllib.unquote_plus(params['resappepisodes']) if 'resappepisodes' in params else ''
    thumbnail = urllib.unquote_plus(params['thumbnail']) if 'thumbnail' in params else ''
    buildNextLists('',app_id,resid,page,resappepisodes,thumbnail)

def display_for_favourite(params):
    display_for_history(params)

def update_favourite(params):
    resid = urllib.unquote_plus(params['resid']) if 'resid' in params else ''
    url = xbmc.getInfoLabel("AppServer.IP") + "/cube/api/resources/"+str(resid)+"?client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
    result = GetHttpData(url)
    res = json.JSONDecoder().decode(result)
    data = res["data"] if 'data' in res else None
    if data:
        title = data["title"].encode("utf-8") if 'title' in data else ''
        thumbnail = data["thumbnail"].encode("utf-8") if 'thumbnail' in data else ''
        episodesCount = str(data["episodesCount"]) if 'episodesCount' in data else ''
        updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))
        listitem=xbmcgui.ListItem(title)
        listitem.setProperty('title',title)
        listitem.setProperty('thumb',thumbnail)
        listitem.setProperty('episodesNum',episodesCount)
        listitem.setProperty('updateUrl',updateUrl)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), updateUrl, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def get_params(url = ''):
    param = []
    paramstring = sys.argv[2] if url=='' else url
    if len(paramstring) >= 2:
        params = paramstring
        cleanedparams = params.replace('?', '')
        if (params[len(params) - 1] == '/'):
            params = params[0:len(params) - 2]
        pairsofparams = cleanedparams.split('&')
        param = {}
        for i in range(len(pairsofparams)):
            splitparams = {}
            splitparams = pairsofparams[i].split('=')
            if (len(splitparams)) == 2:
                param[splitparams[0]] = splitparams[1]
    return param

