# -*- coding: utf-8 -*-
# getlist.py

import urllib,urllib2,re,xbmcplugin,xbmcgui,subprocess,sys,os,os.path,xbmcaddon,md5,hashlib,xbmc   
import json
from customchannels import customChannels
import platform

from xbmcswift2 import Plugin
plugin = Plugin()

__addonid__ = "plugin.video.mflive"
__addon__ = xbmcaddon.Addon(id=__addonid__)
RESOURCES_PATH = os.path.join(__addon__.getAddonInfo('path'), 'media', )
more = os.path.join(RESOURCES_PATH,'more.png')
ADD = os.path.join(RESOURCES_PATH,'add.png')
MANAGE = os.path.join(RESOURCES_PATH,'manage.png')
DEFAULT = os.path.join(RESOURCES_PATH,'default.png')
IMPORT = os.path.join(RESOURCES_PATH,'import.png')
EXPORT = os.path.join(RESOURCES_PATH,'export.png')
CLEAR = os.path.join(RESOURCES_PATH,'clear.png')
REMOVE = os.path.join(RESOURCES_PATH,'remove.png')


def GetHttpData(url):
    #UserAgent = ''
    req = urllib2.Request(url)
    #req.add_header('User-Agent', UserAgent)
    response = urllib2.urlopen(req)
    httpdata = response.read()
    if response.headers.get('content-encoding', None) == 'gzip':
        httpdata = gzip.GzipFile(fileobj=StringIO.StringIO(httpdata)).read()
    response.close()
    match = re.compile('encodingt=(.+?)"').findall(httpdata)
    if len(match)<=0:
        match = re.compile('meta charset="(.+?)"').findall(httpdata)
    if len(match)>0:
        charset = match[0].lower()
        if (charset != 'utf-8') and (charset != 'utf8'):
            httpdata = unicode(httpdata, charset).encode('utf8')
    return httpdata

def buildRoot():
    listitem=xbmcgui.ListItem('2014巴西世界杯')
    url=sys.argv[0]+"?mode=1&&name="+urllib.quote_plus('2014巴西世界杯')+"&app_id="+"&category_id="+urllib.quote_plus('6')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('178')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('中央')
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('中央')+"&app_id="+"&category_id="+urllib.quote_plus('6')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('165')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('卫视')
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('卫视')+"&app_id="+"&category_id="+urllib.quote_plus('6')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('166')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('地方')
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('地方')+"&app_id="+"&category_id="+urllib.quote_plus('6')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('167')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('其他')
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('其他')+"&app_id="+"&category_id="+urllib.quote_plus('6')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('1000')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    customSources = customChannels.getSources()
    for source in customSources:
        os = platform.system()
        if os == 'Windows':
            listitem=xbmcgui.ListItem('自定义频道 - ' + source.decode('gbk').encode('utf-8'), thumbnailImage=ADD)
        else:
            listitem=xbmcgui.ListItem('自定义频道 - ' + source, thumbnailImage=ADD)
        url=sys.argv[0]+"?mode=11&customsource="+urllib.quote_plus(source)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('自定义频道管理', thumbnailImage=MANAGE)
    url=sys.argv[0]+"?mode=12"
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def buildLists(app_id,category_id,area_id,url,page,style_id):
    url1 = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources?app_id="+ str(app_id) +"&category_id=" + str(category_id) + "&area_id="+str(area_id)+"&style_id=" + str(style_id) +"&released_on_from=&released_on_to="+"&page_no="+str(page)+"&page_size=50&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
    if style_id=='178':
        url1 = 'http://files.cube.morefun.tv/mflives/shijiebei.json'
    elif style_id=='165':
        url1 = 'http://files.cube.morefun.tv/mflives/zhongyang.json'
    elif style_id=='166':
        url1 = 'http://files.cube.morefun.tv/mflives/weishi.json'
    elif style_id=='167':
        url1 = 'http://files.cube.morefun.tv/mflives/difang.json'
    elif style_id=='1000':
        url1 = 'http://files.cube.morefun.tv/mflives/qita.json'
    p1 = GetHttpData(url1)
    data = json.JSONDecoder().decode(p1)
    newses = data["data"] if 'data' in data else None
    if newses != None:
        newses1 = newses["items"] if 'items' in newses and newses['items'] else []
        maxpage = newses["totalPages"] if 'totalPages' in newses and newses['totalPages'] else '0'
        p = GetHttpData(url1)
        #if page > 1:
            #listitem=xbmcgui.ListItem('[COLOR FF004AFF]上一页  ' + str(page)+ '/' +str(maxpage) +'[/COLOR]')
            #u=sys.argv[0] + '?mode=1&mfcachetype=dir_cache_always&page='+str(page-1) + '&app_id='+str(app_id)+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&url=' + urllib.quote_plus(url1)
            #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
        for i in newses1:
            name = i["title"].encode("utf-8") if 'title' in i and i['title'] else ''
            resid = i["id"] if 'id' in i and i['id'] else 0
            channelurl = i["channelUrl"].encode("utf-8") if 'channelUrl' in i and i['channelUrl'] else ''
            channelappid = i["channelAppId"].encode("utf-8") if 'channelAppId' in i and i['channelAppId'] else ''
            url = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/"+str(resid)+"?page_size=50&app_id="+str(app_id)+"&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
            thumbnail = i["thumbnail"].encode("utf-8") if 'thumbnail' in i and i['thumbnail'] else DEFAULT
            description = i['description'].encode("utf-8") if 'description' in i and i['description'] else ''
            listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
            u=sys.argv[0]+'?mode=3&mfcachetype=dir_cache_always&url='+urllib.quote_plus(url) +'&app_id='+urllib.quote_plus(str(channelappid))+'&resid='+urllib.quote_plus(str(resid))+'&name='+urllib.quote_plus(name)+'&channelurl='+urllib.quote_plus(channelurl)+'&description='+urllib.quote_plus(description)
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, False, len(newses1))
        if int(maxpage) > page:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' + str(page) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=more)
            u=sys.argv[0] + '?mode=1&mfcachetype=dir_cache_always&page='+str(page+1) + '&app_id='+str(app_id)+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&url=' + urllib.quote_plus(url1)
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'livetv')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def buildNextLists(url,app_id,resid):
    url = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/"+str(resid)+"/episodes?"+"page_size=50&app_id="+str(app_id)+"&client_id="+str(xbmc.getInfoLabel("client.id"))+ "&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
    mylist = GetHttpData(url)
    data1 = json.JSONDecoder().decode(mylist)
    urls = data1["data"]
    urls1 = urls["items"]
    for j in urls1:
        item_id = j["id"]
        name = j["title"].encode("utf-8")
        play_url = j["playUrl"].encode("utf-8")
        listitem=xbmcgui.ListItem(name)
        url=sys.argv[0] + '?mode=3&url=' + urllib.quote_plus(play_url)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, False)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))
        
def buildCustomChannelList(customsource):
    channels = customChannels.getChannelsBySource(customsource)
    for channelName in channels.keys():
        channelurls = channels[channelName][0]
        channelurl = ''
        channelappid = ''
        for url in channelurls:
            channelurl = channelurl + url + ','
            channelappid = channelappid + '0' + ','
        channelurl = channelurl.strip(' ,')
        channelappid = channelappid.strip(' ,')
        if channelurl:
            thumbnail = channels[channelName][1]
            if not thumbnail:
                thumbnail=DEFAULT
            listitem=xbmcgui.ListItem(channelName,thumbnailImage = thumbnail)
            resid = channelName + customsource
            u=sys.argv[0]+'?mode=3&is_custom=true&channelurl='+urllib.quote_plus(channelurl)+'&name='+urllib.quote_plus(channelName)+'&app_id='+urllib.quote_plus(str(channelappid))+'&resid='+urllib.quote_plus(str(resid))
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, False)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def buildCustomManageList():
    listitem=xbmcgui.ListItem('导入频道', thumbnailImage = IMPORT)
    url=sys.argv[0]+"?mode=13"
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem)
    listitem=xbmcgui.ListItem('清空全部自定义频道', thumbnailImage = CLEAR)
    url=sys.argv[0]+"?mode=14"
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem)
    customSources = customChannels.getSources()
    for source in customSources:
        os = platform.system()
        if os == 'Windows':
            listitem=xbmcgui.ListItem(source.decode('gbk').encode('utf-8'), thumbnailImage = REMOVE)
        else:
            listitem=xbmcgui.ListItem(source, thumbnailImage = REMOVE)
        url=sys.argv[0]+"?mode=14&customsource="+urllib.quote_plus(source)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))
    
def importCustomChannels():
    dialog = xbmcgui.Dialog()
    path = dialog.browse(1, '导入频道', 'files')
    os = platform.system()
    if os == 'Windows':
        path = path.decode('utf-8').encode('gbk')
    if path:
        channelCount = customChannels.importChannels(path)
        if channelCount > 0:
            dialog.ok('提示', '成功导入 %d 个频道' %channelCount)
            xbmc.executebuiltin('Container.Refresh')
        elif channelCount == 0:
            dialog.ok('提示', '导入频道失败')

def removeCustomChannels(customsource = ""):
    customSources = customChannels.getSources()
    if len(customSources) == 0:
        return
    line = '确定要移除文件 %s 吗？' %customsource
    if not customsource:
        line = '确定要移除所有文件吗？'
    dialog = xbmcgui.Dialog()
    ret = dialog.yesno("提示", line)
    if ret:
        if not customsource:
            success = 0
            failed = 0
            for source in customSources:
                removed = customChannels.removeChannelSource(source)
                if removed == 0:
                    success = success +1
                else:
                    failed = failed + 1
            if failed == 0:
                dialog.ok('提示', '成功移除所有自定义频道')
                xbmc.executebuiltin('Container.Refresh')
            else:
                dialog.ok('提示', '未完全清空自定义频道')
                xbmc.executebuiltin('Container.Refresh')
        else:
            removed = customChannels.removeChannelSource(customsource)
            if removed == 0:
                dialog.ok('提示', '移除文件 %s 成功' %customsource)
                xbmc.executebuiltin('Container.Refresh')
            else:
                dialog.ok('提示', '移除文件 %s 失败' %customsource)

def performChange(app_id,category_id,url):
    typeid = [1,2,3,5,6]
    typename = ["喜剧","动作","惊悚","科幻","爱情"]
    dialog = xbmcgui.Dialog()
    sel = dialog.select('选择分类', typename)
    page = 1
    if sel != -1:
        style_id=typeid[sel]
        buildLists(app_id,category_id,area_id,url,page,style_id)

def setres(url,resid):
    mylist = GetHttpData(url)
    data1 = json.JSONDecoder().decode(mylist)
    urls = data1["data"]
    appid = urls["appId"]
    appname = urls["appName"].encode("utf-8")
    applist = appid.split(",")
    appnamelist = appname.split(",")
    dialog = xbmcgui.Dialog()
    sel = dialog.select('选择数据源', appnamelist)
    if sel != -1:
        app_id=applist[sel]
        buildNextLists(url,app_id,resid)
    
def setarea():
    listitem=xbmcgui.ListItem('大陆')
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('大陆')+"&area_id="+urllib.quote_plus('2')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('港台')
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('港台')+"&area_id="+urllib.quote_plus('1,9,18')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('日韩')
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('日韩')+"&area_id="+urllib.quote_plus('3,6,17')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('欧美')
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('欧美')+"&area_id="+urllib.quote_plus('4,16,50')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))
    
def get_params():
    param = []
    paramstring = sys.argv[2]
    if len(paramstring) >= 2:
        params = sys.argv[2]
        cleanedparams = params.replace('?', '')
        if (params[len(params) - 1] == '/'):
            params = params[0:len(params) - 2]
        pairsofparams = cleanedparams.split('&')
        param = {}
        for i in range(len(pairsofparams)):
            splitparams = {}
            splitparams = pairsofparams[i].split('=')
            if (len(splitparams)) == 2:
                param[splitparams[0]] = splitparams[1]
    return param    

