# -*- coding: utf-8 -*-
# default.py

import urllib,urllib2,re,xbmcplugin,xbmcgui,subprocess,sys,os,os.path,xbmcaddon
import json
from xbmcswift2 import Plugin
plugin = Plugin()

# Plugin constants 
__addonid__ = "plugin.video.mfyouku"
__addon__ = xbmcaddon.Addon(id=__addonid__)
__cwd__ = __addon__.getAddonInfo('path')
__resource__  = xbmc.translatePath( os.path.join( __cwd__, 'lib' ) )
sys.path.append (__resource__)
import getlist_youku
import itvi_play
    
params = getlist_youku.get_params()
mode = None
url = None
page = 1
type = None

app_id = ''
category_id = ''
area_id = ''
style_id = ''
released_on_from = ''
released_on_to = ''
page_size = ''
resid = ''
item_id = ''
appspidername = ''
maxpage = ''
name = ''
search_path = ''
keyword = ''
searchpage = ''
title = ''
year = ''
actors = ''
resappepisodes = ''
areaname = ''
stylename = ''
thumbnail = ''
get_type = ''
need_type = ''
fromtype = ''
resourceTitle = ''
medianame = ''

try:
    url = urllib.unquote_plus(params["url"])
except:
    pass
try:
    mode = int(params["mode"])
except:
    pass
try:
    page = int(params["page"])
except:
    pass
try:
    searchpage = int(params["searchpage"])
except:
    pass
try:
    type = int(params["type"])
except:
    pass
try:
    app_id = urllib.unquote_plus(params["app_id"])
    if app_id == "0":
        app_id = ""
except:
    pass
try:
    category_id = urllib.unquote_plus(params["category_id"])
except:
    pass
try:
    area_id = urllib.unquote_plus(params["area_id"])
    if area_id == "0":
        area_id = ""
except:
    pass
try:
    style_id = urllib.unquote_plus(params["style_id"])
    if style_id == "0":
        style_id = ""
except:
    pass
try:
    released_on_from = urllib.unquote_plus(params["released_on_from"])
    if released_on_from == "0":
        released_on_from = ""
except:
    pass
try:
    released_on_to = urllib.unquote_plus(params["released_on_to"])
    if released_on_to == "0":
        released_on_to = ""
except:
    pass
try:
    page_size = int(params["page_size"])
except:
    pass
try:
    resid = int(params["resid"])
except:
    pass
try:
    item_id = int(params["item_id"])
except:
    pass
try:
    appspidername = urllib.unquote_plus(params["appspidername"])
except:
    pass
try:
    maxpage = int(params["maxpage"])
except:
    pass
try:
    name = urllib.unquote_plus(params["name"])
except:
    pass
try:
    search_path = urllib.unquote_plus(params["search_path"])
except:
    pass
try:
    keyword = urllib.unquote_plus(params["keyword"])
except:
    pass
try:
    title = urllib.unquote_plus(params["title"])
except:
    pass
try:
    year = urllib.unquote_plus(params["year"])
except:
    pass
try:
    actors = urllib.unquote_plus(params["actors"])
except:
    pass
try:
    areaname = urllib.unquote_plus(params["areaname"])
except:
    pass
try:
    stylename = urllib.unquote_plus(params["stylename"])
except:
    pass
try:
    resappepisodes = urllib.unquote_plus(params["resappepisodes"])
except:
    pass
try:
    thumbnail = urllib.unquote_plus(params["thumbnail"])
except:
    pass
try:
    get_type = urllib.unquote_plus(params["get_type"])
except:
    pass
try:
    need_type = urllib.unquote_plus(params["need_type"])
except:
    pass
try:
    fromtype = urllib.unquote_plus(params["fromtype"])
except:
    pass
try:
    resourceTitle = urllib.unquote_plus(params["resourceTitle"])
except:
    pass
try:
    medianame = urllib.unquote_plus(params["medianame"])
except:
    pass

if get_type:
    if get_type == "area":
        getlist_youku.getareas(need_type, category_id, medianame)
    elif get_type == "style":
        getlist_youku.getstyles(need_type, category_id, medianame)
    elif get_type == "year":
        getlist_youku.getyears(need_type, category_id, medianame)
elif fromtype == 'history':
   getlist_youku.display_for_history(params)
elif fromtype == 'favourite':
   getlist_youku.display_for_favourite(params)
elif fromtype == 'updateFavourite':
   getlist_youku.update_favourite(params)

elif mode == None:
    getlist_youku.buildRoot()
elif mode == 1:
    getlist_youku.buildLists(category_id,page,area_id,style_id,released_on_from,released_on_to,medianame)
elif mode == 2:
    getlist_youku.buildNextLists(app_id,category_id,url,name,thumbnail,page,resappepisodes,medianame)
elif mode == 3:
    source_id = int(app_id)
    additional_property_dict = "AnalysisRealUrlForMorefun"
    source_kind = ""
    item_id = str(item_id)
    spiderName = appspidername
    videoParam = ""
    properties = {}
    properties['itemType'] = 'morefun'
    properties['sourceId'] = source_id
    properties['url'] = url
    properties['sourceKind'] = source_kind
    properties['itemId'] = item_id
    properties['spiderName'] = spiderName
    properties['videoParam'] = videoParam
    properties['title'] = name
    properties['resourceTitle'] = resourceTitle
    properties['thumb'] = thumbnail
    folderpath = xbmc.getInfoLabel('container.folderpath')
    pos = folderpath.find('?')
    host = folderpath[0:pos]
    params = getlist_youku.get_params(folderpath[pos:])
    app_id = params['app_id'] if 'app_id' in params else ''
    resid = params['resid'] if 'resid' in params else ''
    category_id = params['category_id'] if 'category_id' in params else ''
    url = params['url'] if 'url' in params else ''
    name = params['name'] if 'name' in params else ''
    if not name:
        name = params['title'] if 'title' in params else ''
    page = params['page'] if 'page' in params else ''
    resappepisodes = params['resappepisodes'] if 'resappepisodes' in params else ''
    thumbnail = params['thumbnail'] if 'thumbnail' in params else ''
    parentPath = host+'?fromtype=history&app_id='+app_id+'&resid='+resid+'&page='+page+'&resappepisodes='+resappepisodes+'&thumbnail='+thumbnail +'&category_id='+category_id+'&url='+url+'&name='+name
    properties['parentPath'] = parentPath
    player = itvi_play.ItviItemPlayer()
    player.play(properties)
elif mode == 4:
    pass
elif mode == 5:
    pass
elif mode == 6:
    pass
elif mode == 7:
    pass
elif mode == 8:
    getlist_youku.searchkey(category_id)
elif mode == 9:
    getlist_youku.searchlist(keyword,category_id,category_mf,searchpage)